<?php
namespace Teknisa\EST\Modules\EstoqueCego\Controllers;

use Teknisa\EST\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Request\Filter;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO;

class Est93000DigitacaoInventarioCegoController extends TeknisaCrud {

    protected $dataSourceName = "";
    protected $parameterBagColumns = [];
    protected $dataSourceManager;
    protected $environment;
    protected $crudService;
    
    public function __construct($crudService, $parameterBag, $dataSourceManager, $environment) {

        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
    }
    
    public function save(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            
            // saving quantity to each product
            $lastElement = count($row)-1;
            if(isset($row['inlineEdit']) && $row['inlineEdit'] == true){
                $dataSet= array();
                
                foreach($row as $data){
                    if(isset($data['changed'])) $dataSet[] = $data;
                }
                
                $newDatasetToSave = new DataSet('iteminventcego', $dataSet);
                $newRequestToSave = new DTO\Request\DataSet($newDatasetToSave, '', '', '');
                $rowsToSave = $this->crudService->getRowsToSave($newRequestToSave, "iteminventcego");
                $dataSetToSave = new DataSet("iteminventcego", $rowsToSave);
                $this->dataSourceManager->persist($dataSetToSave);
            }else{
                $this->dataSourceName = 'iteminventcego';
                $newDatasetToSave = new DataSet('iteminventcego', [$row]);
                $newRequestToSave = new DTO\Request\DataSet($newDatasetToSave, '', '', '');
                $rowsToSave = $this->crudService->getRowsToSave($newRequestToSave, "iteminventcego");
                $dataSetToSave = new DataSet("iteminventcego", $rowsToSave);
                $this->dataSourceManager->persist($dataSetToSave);
            }
            
            //changing inventory status to 'ED'
            $inventoryRow = [
                "IDSITESTCEGO"  =>  "ED",
                "CDFILIAL"      =>  isset($row[0]) ? $row[0]['CDFILIAL'] : $row['CDFILIAL'],
                "CDALMOXARIFE"  =>  isset($row[0]) ? $row[0]['CDALMOXARIFE'] : $row['CDALMOXARIFE'],
                "CDLOCALESTOQ"  =>  isset($row[0]) ? $row[0]['CDLOCALESTOQ'] : $row['CDLOCALESTOQ'],
                "DTCONTAGEM"    =>  isset($row[0]) ? $row[0]['DTCONTAGEM'] : $row['DTCONTAGEM'],
                "NRORG"         =>  $this->environment->getNrOrgTrab(),
                "__is_new"      =>  false
            ];
            
            $this->dataSourceName = 'inventestcego';
            $newRequest = new DTO\Request\Row ($inventoryRow, '', '', '');
            parent::save($newRequest, $response);
            $response->addDataSet(new DataSet("inventory", $inventoryRow));
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
    public function concludeDigitation(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            $row['IDSITESTCEGO'] = "DG";
            
            $this->dataSourceName = 'inventestcego';
            parent::save($request, $response);
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}
