<?php
namespace Teknisa\EST\Modules\Relatorios\Controllers;

use Teknisa\EST\Modules\Relatorios\Services\Est31100PosicaoDeEstoqueService;
use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Est31100PosicaoDeEstoqueController extends \Teknisa\EST\Controllers\TeknisaCrud {

    protected $posicaoService;
    protected $dataSourceName = "posestdia_posicao_estoque";
    protected $parameterBagColumns = [
        "NMTIPOCUSTO",
        "NVTOT",
        "CDARVPRODFIN",
        "CDARVPRODINI",
        "CDTIPOCUSTO",
        "ORDENANOME",
        "DTPOSICAO",
        "DATAPOS",
        "CDALMOXARIFE",
        "CDFILIAL",
        "CDLOCALESTOQ"
    ];

    public function __construct(CrudService $crudService, ParameterBag $parameterBag, Est31100PosicaoDeEstoqueService $posicaoService) {
        $this->posicaoService = $posicaoService;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        //remover este comentario
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            foreach ($conditions as $condition) {
                if(is_string($condition["columnName"])) {
                    $row[$condition["columnName"]] = $condition["value"];
                    $cleanConditions[] = $condition;
                }
            }
            $this->posicaoService->validateParameters($row);

            $newFilterCriteria = new FilterCriteria($this->dataSourceName, $cleanConditions);
            $filter = new DTO\Request\Filter($newFilterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());

            parent::find($filter, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}