<?php
namespace Fiscal\Logic\Apuracoes\Exceptions;

class ExcecaoContribuicoes extends \Fiscal\Logic\Exception
{
    private $messageName;

    public function __construct($messageName, $code = 0, \Exception $previous = null)
    {
        parent::__construct($messageName, $code, $previous);
        $this->messageName = $messageName;
    }
    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    public static function Validacao01(){
        throw new self ('msg_pbi00136_01'); //Data inicial para verificação de notas fiscais fora do período deve ser menor que a data inicial do mapa de apuração.
    }

    public static function Validacao02(){
        throw new self ('msg_pbi00136_02'); //Data final deve ser maior que a data inicial.
    }

    public static function Validacao03(){
        throw new self ('msg_pbi00136_03'); //Existem notas fora do período na apuração.
    }

    public static function Validacao04(){
        throw new self ('msg_pbi00136_04'); //O mapa de apuração está bloqueado. Impossível realizar alterações.
    }

    public static function Validacao05(){
        throw new self ('msg_pbi00136_05'); //Os mapas anteriores devem estar bloqueados.
    }

    public static function Validacao06(){
        throw new self ('msg_pbi00136_06'); //Os mapas posteriores devem estar desbloqueados.
    }

    public static function Validacao07(){
        throw new self ('msg_pbi00136_07'); //Data de vencimento da guia de contribuição deve ser informada.
    }

    public static function Validacao08(){
        throw new self ('msg_pbi00136_08'); //Código da receita cumulativo da guia de contribuição deve ser informado.
    }

    public static function Validacao09($cdsitutribpico){
        throw new self ('Existe nível superior cadastrado para o CST NF-e '.$cdsitutribpico.'.');
    }

    public static function Validacao10($cdsitutribpico){
        throw new self ('Conta contábil já cadastrado para o CST NF-e '.$cdsitutribpico.'.');
    }

    public static function Validacao11($cdsitutribpico){
        throw new self ('Existe nível inferior cadastrado para o CST NF-e '.$cdsitutribpico.'.');
    }

    public static function Validacao12(){
        throw new self ('msg_pbi00136_12'); //Código da receita não cumulativo da guia de contribuição deve ser informado.
    }

    public static function Validacao13(){
        throw new self ('msg_pbi00136_13'); //Mapa não pode ser excluído. Não é o último mapa deste imposto.
    }
}