function Est58000_RetiradaEstoque_Controller(ScreenService, General, templateManager, Est58000_RetiradaEstoque_Service, ValidacoesEstoque_Service, Lib00206_InfComplProduto_Controller, ZHPromise, restEngine, metaDataFactory, ZhFilterPreferences, MessageService, EstUtil) {

	this.cdTipCustEst = 3;
	this.filialctrlestoq = 'S';


	/**
	 * Essa função tem como objetivo executar a função do botão de voltar da tela. Quando em modo de
	 * inserir retirada ele roda o data da widget para achar qual posição estava sendo editada/inserida.
	 * Quando encontrado, seta a currentRow e a posição no data com o backup feito na função do modo
	 * de edição, troca a editabilidade de alguns campos e passa a widget para o modo view.
	 * Quando o registro esta sendo inserido, ainda no modo inserir retirada, a posição do data é
	 * retirada.
	 * Quando não está no modo de inserir uma retirada, chama função do General que cancela a edição
	 * ou inserção.
	 *
	 * @param args | evento da action
	 */
	this.backEditItens = function(args) {
		var widget = args.owner.widget;
		let widgetRetiradaViaLeitor = templateManager.container.getWidget('retiradaTabbed');
		let widgetProdutos = templateManager.container.getWidget('produtos');
		let widgetRetirada = templateManager.container.getWidget('retirada');

		if (widget.call === 'insertRetirada' && !widget.currentRow.novo) {
			widget.dataSource.data.forEach(function(row, rowIndex, rows) {
				if (widget.currentRow === row) {
					rows[rowIndex] = widget.backupRow;
					widget.currentRow = widget.backupRow;

					this.changeReadOnlyByName(widget, 'QTTOTLANCTO', true);
					this.changeReadOnlyByName(widget, 'QTDEVOLESTOQ', true);

					widget.view();
				}
			}.bind(this));
		}
		else {
			General.backOrCancel(args);
		}

		if (widget.name === 'produtos') {
			ScreenService.closeSwipe().then(fechou => {});
		}
	};

	/**
	 * Essa função tem como finalidade verificar o valor do campo de produto na inserção
	 * de um item na retirada. Quando tem valor chama a Lib que abre o popup de Informações
	 * Complementares de Produto e na sequência permite que outros campos sejam editavéis.
	 * Caso o campo não tenha valor, os campos, antes habilitados, são desabilitados para
	 * edição. Depois os valores dos campos que aparecem na tela são zerados.
	 *
	 * @param widget | widget de itens da retirada
	 */
	this.callInformacoesComplmentares = function(widget) {
		var promise = ZHPromise.defer();
		let widgetReti = widget.container.getWidget('retirada');
		if (widget.currentRow.CDARVPROD) {
			widget.promise = promise;
			let filterRow = isset(() => widgetReti.appliedFilter.FILTER_ROW) ? widgetReti.appliedFilter.FILTER_ROW : false;
			if (isset(() => filterRow.CDALMOXARIFE)) {
				if (filterRow.CDALMOXARIFE != ' ')
					widget.currentRow.CDALMOXARIFE = filterRow.CDALMOXARIFE;
			}
			if (isset(() => filterRow.CDLOCALESTOQ)) {
				if (filterRow.CDLOCALESTOQ != ' ')
					widget.currentRow.CDLOCALESTOQ = filterRow.CDLOCALESTOQ;
			}
			Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
			this.changeReadOnlyByName(widget, "QTTOTLANCTO", false);
			this.changeReadOnlyByName(widget, "QTDEVOLESTOQ", false);
			this.clearRowItens(widget, false);
		}
		else {
			this.changeReadOnlyByName(widget, "QTTOTLANCTO", true);
			this.changeReadOnlyByName(widget, "QTDEVOLESTOQ", true);
			this.clearRowItens(widget, true);
			promise.reject();
		}
		return promise;

	};

	/**
	 * Essa função tem como finalidade carregar a widget de itens da retirada, e setar na
	 * widget de retirada o campo de Tipo de Retirada, colocando na currentRow no código
	 * e nome do tipo de retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.carregaItems = function(widget) {
		var widgetItens = widget.widgets[0];
		if (!widget.currentRow.__is_new) {
			widgetItens.reload().then(function() {
				widget.currentRow.CDTIPORETI = widgetItens.dataSource.data[0].CDTIPORETI;
				widget.currentRow.NMTIPORETI = widgetItens.dataSource.data[0].NMTIPORETI;
			});
		}
		else {
			widgetItens.dataSource.data = [];
		}

	};


	/**
	 * Essa função tem como finalidade percorrer o filtro montado pelo ZhFilter. É verificado
	 * se o usuario selecinou almoxarifado e/ou localização, se não tiver selecionado é
	 * inserido no filtro almoxarifado e/ou localizacao com o valor de T para aquele que não
	 * foi selecionado no filtro. É verificado também, se o filtro recebeu data, se não tiver
	 * recebido é passado no filtro DATA o valor T, se tiver recebido é passado NULL.
	 *
	 * @param widget | widget com name de "retirada"
	 */
	this.changeFilter = function(widget, preference) {
		var filterRow = preference.FILTER_ROW;
		var filterData;
		var dtinicial, dtfinal, data, cdalmoxar, cdlocal;
		let actAdicionar = widget.getAction('adicionar');
		actAdicionar.isVisible = this.filialctrlestoq == 'S' ? true : false;

		if (filterRow.DTINICIAL && filterRow.DTFINAL) {
			dtinicial = filterRow.DTINICIAL;
			dtfinal = filterRow.DTFINAL;
			data = null;
		}
		else {
			dtinicial = null;
			dtfinal = null;
			data = 'T';
		}
		if (filterRow.ALMOXARIFE && (filterRow.ALMOXARIFE != "")) {
			cdalmoxar = filterRow.ALMOXARIFE;
		}
		else {
			cdalmoxar = 'T';
		}
		if (filterRow.CDLOCALESTOQ && (filterRow.CDLOCALESTOQ != "")) {
			cdlocal = filterRow.CDLOCALESTOQ;
		}
		else {
			cdlocal = 'T';
		}
		var filter = [{
				"name": "CDFILIAL",
				"operator": "=",
				"value": filterRow.CDFILIAL
			},
			{
				"name": "CDALMOXARIFE",
				"operator": "=",
				"value": cdalmoxar
			},
			{
				"name": "CDLOCALESTOQ",
				"operator": "=",
				"value": cdlocal
			},
			{
				"name": "DTINICIAL",
				"operator": "=",
				"value": dtinicial
			},
			{
				"name": "DTFINAL",
				"operator": "=",
				"value": dtfinal
			},
			{
				"name": "DATA",
				"operator": "=",
				"value": data
			}
		];
		//filter.push(filterData[0]);
		widget.dataSourceFilter = filter;
		widget.reload();
	};

	this.intervaloChange = function(field) {
		let widget = field.widget;
		widget.currentRow.DTINICIAL = widget.currentRow.INTERVALO.start;
		widget.currentRow.DTFINAL = widget.currentRow.INTERVALO.end;
	};

	/**
	 * A função tem a finalidade de trocar as propriedades label, hideicon e isvisible
	 * de uma action que será selecionada pelo seu nome.
	 *
	 * @param data | array de objetos (as actions)
	 * @param label | string com o novo valor da propriedade label
	 * @param hide | boolean com o valor para setar a propridade hideIcon
	 * @param name | string com o nome da action que vai ser alterada
	 * @param visibility | boolean para setar a visibilidade de action
	 */
	this.changeHideInconLabelVisible = function(data, label, hide, name, visibility) {
		data.forEach(function(element) {
			if (element.name === name) {
				element.label = label;
				element.hideIcon = hide;
				element.isVisible = visibility;
			}
		});
	};

	/**
	 * Essa função tem como finalidade trocar o valor da propriedade readOnly
	 * de um field de uma widget.
	 *
	 * @param widget | widget onde sera pego o campo.
	 * @param name | nome do field que vai ser pegado da widget e alterado a propriedade
	 * @param read | true ou false para habilitar ou não a propriedade
	 */
	this.changeReadOnlyByName = function(widget, name, read) {
		widget.getField(name).readOnly = read;
	};

	/**
	 * Essa função tem como finalidade controlar as validações do campo de campo de
	 * localização chegando se a unidade do filtro controla localização de almoxarifado
	 * e se o campo de almoxarifado está preenchido. Se ambos forem verdadeiros, habilita
	 * o campo, se não desabilita o campo e limpa a currentRow dos dados de localização
	 *
	 * @param widget | widget do filtro
	 */
	this.changeReadOnlyLocal = function(widget) {
		var almox = widget.currentRow.CDALMOXARIFE;
		var flocal = widget.getField('DSLOCALESTOQ');
		if (almox && Est58000_RetiradaEstoque_Service.utilizaLocalizacao()) {
			flocal.readOnly = false;
			flocal.reload();
		}
		else {
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			flocal.readOnly = true;
		}
	};

	/**
	 * Essa função é chamada quando é aberta alguma row na widget de itens de retirada. Ela
	 * tem a função de verificar se o registro selecionado está com as informações completas.
	 * Se não estiver abre a tela de Informações Complementares de Produto, se estiver completo,
	 * não faz nada.
	 * A tela de Informações Complementares de Produto sempre será chamada quando for inserida
	 * uma retirada com requisição, mesmo que os produtos da requisição venham com todas as
	 * informações complementares, pois é necessária a confirmação das mesmas por parte do usuário.
	 *
	 * @param args | evento da widget
	 */
	this.checkAlmoxStatus = function(args) {
		var widget = args.owner;
		if (widget.currentRow.COMPLETO !== 'S') {
			widget.currentRow.CDFILIMOVI = EstUtil.getFieldValue('CDFILIAL', 'retirada', true);
			this.editItens(widget);
			this.callInformacoesComplmentares(widget);
		}
	};



	/**
	 * Essa função tem a finalidade de voltar as actions para o estado normal depois
	 * de cancelar a inserção de uma retirada sem requisição.
	 *
	 * @param args | evento da action
	 */
	this.checkBackAction = function(args) {
		var widget = args.owner.widget;
		if (widget.call === 'insertRetirada') {
			General.backOrCancel(args);
			this.returnStatus(widget.getParent());
			ScreenService.closeSwipe(0);
			widget.getParent().list(true);
			widget.getParent().dataSource.data.pop();
			widget.getParent().currentRow = {};
			widget.getParent().enabled = true;
			widget.getParent().activate();
		}
		else if (widget.call === 'padrão') {
			ScreenService.goBack();
		}
	};

	this.checkBackAct = function(args) {
		var widget = args.owner.widget;
		let tabbedWidget = templateManager.container.getWidget('retiradaTabbedLeitor');
		let widgetPrincipal = templateManager.container.getWidget('retirada');
		let widgetGridItens = templateManager.container.getWidget('gridProdutosLeitor');

		widgetGridItens.dataSource.data = [];
		ScreenService.closeSwipe();
		//tabbedWidget.isVisible = false;
		widgetPrincipal.activate();

		tabbedWidget.dataSource.data = [];
		tabbedWidget.currentRow = {};
		widgetGridItens.currentRow = {};
		tabbedWidget.isVisible = false;
		//ScreenService.goBack();

		if (tabbedWidget.currentRow.changed) {
			tabbedWidget.currentRow.changed = false;
		}
	};

	/**
	 * Essa função tem a finalidade de verificar se existe algum produto que ainda não teve
	 * suas informações complementares colocadas e está sendo salvo. Se isso acontecer, dá uma
	 * mensagem ao usuário e retorna false para a função que lhe chamou.
	 *
	 *	@param data | data da widget de itens
	 */
	this.checkProdutosCompletos = function(data) {
		var validação = true;
		data.forEach(function(produto) {
			if (produto.COMPLETO !== 'S') {
				validação = false;

				// ScreenService.showMessage('Não é possível salvar pois faltam informações para o produto ' + produto.NMPRODUTO + '.');

				/* MSG NOVA */
				var variaveis = {
					NMPRODUTO: produto.NMPRODUTO
				};

				MessageService.showMessageByCode("PRODUTOIRREGULAR", variaveis);
				/* FIM MSG NOVA */

			}
		});
		return validação;
	};

	this.checkRequisicaoComplementarCreation = function(widget) {
		var promise = ZHPromise.defer();
		var item = widget.currentRow;

		if (this.checkShouldCreateRequisicaoComplementar(item)) {
			var msg = "Quantidade requisitada não disponível em estoque para o produto " + item.NMPRODUTO + " : " + item.QTESTOQDIA + " " + item.SGUNIDADE + ". Deseja gerar uma requisição complementar?";

			ScreenService.confirmMessage(msg,
				'question',
				function() { //sim
					item.createReqComp = true;
					item.QTLANCREQCOMP = item.QTREQUESTO - item.QTESTOQDIA;

					promise.resolve();
				}.bind(this),
				function() { //não
					item.createReqComp = false;

					promise.resolve();
				}.bind(this));
		}
		else promise.resolve();

		return promise;
	};

	this.checkShouldCreateRequisicaoComplementar = function(item) {
		return item.NRREQUESTO && item.IDREQCOMPEST == 'S' &&
			item.QTESTOQDIA == item.QTLANCTOEST &&
			item.QTESTOQDIA < item.QTREQUESTO;
	};

	/**
	 * Essa função tem como finalidade controlar em qual estado o usuário esta usando a tela
	 * e chamar a função correspondente ao estado que ela está.
	 *
	 * @param widget | widget de retirada
	 */
	this.checkSaveMod = function(widget) {
		if (widget.isValid()) {
			if (widget.currentRow.__is_new && widget.currentRow.NRREQUESTO) {
				widget.enabled = false;
				this.getItensOfRequisicao(widget.widgets[0], widget.currentRow.CDFILIAL, widget.currentRow.NRREQUESTO);
				this.focusAddProduto(widget.widgets[0]);
			}
			else if (widget.currentRow.__is_new) {
				widget.enabled = false;
				this.focusAddProduto(widget.widgets[0]);
			}
			else if (!widget.currentRow.__is_new) {
				this.saveEditRetirada(widget);
			}
		}
	};

	/**
	 * Essa função tem como finalidade, primeiramente, verificar se o produto que está sendo
	 * inserido ja foi inserido anteriormente na retirada. Depois verifica o estado da widget para
	 * executar a função certa para o estado correto da widget. Quando essa função é chamada
	 * no momento de adicionar um item em uma retirada, que está sendo incluida, executa as
	 * funções próprias desse estado. Se estiver no estado de adicionar um item a uma
	 * retirada que já existe, executa as funções deste modo da widget.
	 *
	 * @param widget | widget de itens
	 */
	this.checkSaveProduto = function(widget, forceSave) {
		if (!forceSave) forceSave = false;
		var row = widget.currentRow;

		if (widget.mode === 'edit' ||
			!Est58000_RetiradaEstoque_Service.checaItensDaRetirada(this.copyDataWidgetItens(widget.dataSource.data), row.CDARVPROD, row.CDALMOXARIFE, row.CDLOCALESTOQ, row.NRLOTEESTQ, row.NRSUBLOTE)) {
			if (widget.call === 'insertRetirada') {
				if (widget.isValid() && (forceSave || this.onChangeQt(widget))) {
					ScreenService.showLoader();
					this.checkRequisicaoComplementarCreation(widget).then(function() {
						this.changeReadOnlyByName(widget, 'QTTOTLANCTO', true);
						this.changeReadOnlyByName(widget, 'QTDEVOLESTOQ', true);

						widget.currentRow.novo = false;

						ScreenService.hideLoader();
						ScreenService.closeSwipe();
					}.bind(this));
				}
			}
			else if (widget.call === 'padrão') {
				widget.currentRow.novo = false;
				this.save(widget.getParent());
			}

			let widgetItens = templateManager.container.getWidget('itens');
			let impAction = widgetItens.getAction('importTxt');
			impAction.isVisible = widgetItens.dataSource.data.length == 0;
		}
		else {
			ScreenService.showMessage('Produto informado já está sendo incluido para essa retirada.');
		}
	};

	/**
	 * Essa função tem como finalidade limpar alguns dados da currentRow quando o produto mudar
	 * (inserindo um produto em uma retirada que está sendo inserida). Qunado troca-se o produto,
	 * só os capos de valor são alterados, quando o valor do campo é null, é passado true para
	 * clearAll e valores relacionados ao produto são limpados também.
	 *
	 * @param widget | widget de itens
	 * @param clearAll | parametro para lipar ou não todos os capos da currentRow
	 */
	this.clearRowItens = function(widget, clearAll) {
		if (widget.currentRow.COMPLETO === 'S') {
			widget.currentRow.QTREQUESTO = "";
			widget.currentRow.QTTOTLANCTO = "";
			widget.currentRow.QTDEVOLESTOQ = "";
			widget.currentRow.QTLANCTOEST = "";
			widget.currentRow.VRTOTLANCTO = "";
			if (clearAll) {
				widget.currentRow.NMPRODUTO = "";
				widget.currentRow.CDARVPROD = "";
				widget.currentRow.SGUNIDADE = "";
				widget.currentRow.VRUNILANCTO = "";
			}
		}
	};

	/**
	 * Essa função tem como finalidede clonar todos os dados do dataSource da widget, de
	 * itens principalmente. Não clonando escopos das actions que podem estar na row da
	 * widget.
	 *
	 * @param data | array de objetos; dataSource.data da widget
	 * @return arrray | array de objetos clonados do data da widget
	 */
	this.copyDataWidgetItens = function(data) {
		var copy = [];
		data.forEach(function(item) {
			copy.push(Util.clone(item, ['__rightActions', '__leftActions']));
		});
		return copy;
	};

	/**
	 * Essa função tem a finalidade verificar em qual modo está sendo chamado a função de excluir um
	 * item da retirada. Conforme o modo, chama a função respectiva.
	 *
	 * @param widget | widget de itens
	 */
	this.deleteItem = function(widget) {
		if (widget.getParent().currentRow.EXISTECONSUMO != 'S') {
			if (widget.call === 'insertRetirada') {
				//Exclui um item do grupod de itensque sera incluso junto com uma nova retirada
				this.removeItemDataSource(widget);
			}
			else if (widget.call === 'padrão') {
				this.removeItemRetirada(widget);
			}
		}
		else {
			ScreenService.showMessage("Operação bloqueada! Não é possível excluir pois existe um consumo.");
		}

	};

	/**
	 * Inicialmente a função verifica se aquela retirada pode ser editada (inserir/excliuir/editar um
	 * item é editar uma retirada), se não puder é dada uma mesagem para o usuario. Se puder ser editado
	 * a currentRow é clonada (não é clonada __rightActions e __leftActions pois são escopos), a widget é
	 * colocado em modo de edição e a editabilidade de alguns campos é alterada
	 *
	 * @param widget | widget de itens
	 */
	this.editItens = function(widget) {
		if (widget.getParent().currentRow.NRLANCESTQSAID != null) {
			ScreenService.showMessage("Operação bloqueada! Lançamento vindo da tela de Processamento de Produtos, não pode ser alterado.");
		}
		else {
			if (widget.getParent().currentRow.EXISTECONSUMO != 'S') {
				if (!widget.getParent().currentRow.NRORDPROD) {
					if (!widget.getParent().currentRow.NRLANCESTRET) {
						widget.backupRow = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
						widget.edit();
						this.changeReadOnlyByName(widget, 'QTTOTLANCTO', false);
						this.changeReadOnlyByName(widget, 'QTDEVOLESTOQ', false);
					}
					else {
						ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
					}
				}
				else {
					ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Não é possível editar pois existe um consumo.");
			}
		}
	};

	/**
	 * Essa função tem como finalidade trocar o label do botão de salvar (para garantir que ficará
	 * com a label certa), colocar a widget em modo de edição e desabilitar a widget de produtos.
	 * Isso acontece ao acionar o botão de editar a retirada.
	 * Antes disso é verificado se a retirada pode ser editada, verificando os capos NRORDPROD e
	 * NRLANCESTRET, onde se um deles estiver preencido, é dado sua respctiva mensagem, impedindo
	 * o usuário de editar a retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.editRetirada = function(widget) {
		if (widget.currentRow.NRLANCESTQSAID != null) {
			ScreenService.showMessage("Operação bloqueada! Lançamento vindo da tela de Processamento de Produtos, não pode ser alterado.");
		}
		else {
			if (widget.currentRow.EXISTECONSUMO == "N") {
				if (!widget.currentRow.NRORDPROD) {
					if (!widget.currentRow.NRLANCESTRET) {
						General.edit(widget);
						this.enabledWidget(false);
					}
					else {
						ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
					}
				}
				else {
					ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Não é possível editar pois existe um consumo.");
			}
		}
	};

	/**
	 * Essa função tem como finalidade habilitar e desabilitar a widget "itens", onde
	 * são exibidos os produtos da retirada. Ela é a widget filha da widget "retirada".
	 *
	 * @param enabled | booleano para habilitar ou desabilitar a widget de itens
	 */
	this.enabledWidget = function(enabled) {
		var widget = templateManager.container.getWidget('itens');
		widget.enabled = enabled;
	};

	/**
	 * Essa função tem a finalidade de ativar a widget de produto, deixá-la ativa,
	 * setar uma propriedade de controle e mudar a configuração das actions para
	 * funcionarem no modo de inserir retirada sem requisição.
	 *
	 * @param widget | widget de itens
	 */
	this.focusAddProduto = function(widget) {
		this.enabledWidget(true);
		widget.call = 'insertRetirada';
		widget.activate();
		widget.floatingControl.refreshAction = false;
		this.changeHideInconLabelVisible(widget.actions, 'Cancelar', true, 'VoltarList', true);
		this.changeHideInconLabelVisible(widget.actions, 'Adicionar', true, 'salvar', true);
		this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'salvarNaRetirada', true);
	};

	/*	this.forEachValorUnitario = async function(dataSource, widgetItens) {
			    for (var item of dataSource) {
			        // wait for this to resolve and after that move to next object 
			        widgetItens.currentRow = item;
					widgetItens.currentRow.QTTOTLANCTO = item.QTREQUESTO;
					this.setCdfilimovi(widgetItens);
			        await this.setValorUnitario(widgetItens);
			    }
	};*/

	/**
	 * Essa função tem a finalidade chamar uma função que retornara os itens da requisição
	 * que foi passada na inserção da retirada. Quando retornada o resultado da consulta,
	 * o dataSet é colocado no data da widget de itens.
	 *
	 * @param widgetsItens | widget de itens
	 * @param cdfilial | código da filial de lançamento
	 * @param nrrequesto | código da requisição
	 */
	this.getItensOfRequisicao = function(widgetItens, cdfilial, nrrequesto, itemData, firstTime = true) {
		if (!firstTime) {
			var item = itemData.shift();
			if (item !== undefined) {
				widgetItens.dataSource.data.shift();
				widgetItens.currentRow = item;
				widgetItens.currentRow.QTTOTLANCTO = item.QTREQUESTO;
				widgetItens.currentRow.IDCNTRESTOQ = 'S';
				widgetItens.currentRow.NRSEQUITEM = Est58000_RetiradaEstoque_Service.geraNrsequitem(widgetItens.dataSource.data);
				this.setCdfilimovi(widgetItens);
				this.callInformacoesComplmentares(widgetItens).then(() => {
					this.setValorUnitario(widgetItens).then(() => {
						widgetItens.dataSource.data.push(widgetItens.currentRow);
						this.getItensOfRequisicao(widgetItens, cdfilial, nrrequesto, itemData, false);
					});
				});
			}
			else {

			}
		}
		else {
			Est58000_RetiradaEstoque_Service.getItensOfRequisicao(cdfilial, nrrequesto).then((itens) => {
				widgetItens.dataSource.data = itens;
				var data = Util.clone(widgetItens.dataSource.data);
				this.getItensOfRequisicao(widgetItens, cdfilial, nrrequesto, data, false);
			});
		}

	};

	/**
	 * Essa função tem como finalidade consultar as parametrizações da filial selecionada
	 * no filtro, caso ainda não tenha sido selecionada nenhuma filial no filtro, é usado
	 * o valor FILIAL_LOGADA, que pegara o código da filial logada no backend. Se não
	 * retornar nenhum erro, chama uma função que vai setar valores default para outros
	 * campos do filtro.
	 *
	 * @param widget | widget
	 */
	this.getParamFilialOnce = function(widget) {
		this.setFieldsGerais(widget);
		var filterRow = {};
		this.getFilialLogada().then(function(success) {
			let returnedDataset = success.dataset.paramfilial_paramvalidacoes[0];
			filterRow.CDFILIAL = returnedDataset.CDFILIAL;
			filterRow.NMFILIAL = returnedDataset.NMFILIAL;
			this.filialctrlestoq = returnedDataset.IDCTRLESTQ;

			if (returnedDataset.IDCTRLESTQ == 'N')
				ScreenService.showMessage('Filial logada não controla estoque.');

			ZhFilterPreferences.openFilterWidget(widget, filterRow).then(function() {
				var filial = widget.currentRow.CDFILIAL || 'FILIAL_LOGADA';
				Est58000_RetiradaEstoque_Service.getParamFilial(filial, true).then(function(succes) {
					let widgetFiltro = templateManager.container.getActiveWidget();
					if (Array.isArray(succes)) {
						this.setCampos(widgetFiltro, succes, filial);
					}
					else {
						ScreenService.showMessage(succes);
					}
				}.bind(this), function(error) {
					ScreenService.showMessage(error.data.error);
				});
			}.bind(this));
		}.bind(this));
	};

	this.getFilialLogada = function(filial = 'FILIAL_LOGADA') {
		var filter = [{
			"name": "CDFILIAL",
			"operator": "=",
			"value": filial
		}];
		return General.callRestEngine('est#/crud/paramfilial_paramvalidacoes', 'FilterData', filter);
	};

	this.setFieldsGerais = function(widget) {
		templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
	};

	this.getParamFilial = function(widget) {
		var filial = widget.currentRow.CDFILIAL;
		if (filial) {
			Est58000_RetiradaEstoque_Service.getParamFilial(filial, true).then(function(succes) {
				if (Array.isArray(succes)) {
					this.setCampos(widget, succes, filial);
				}
				else {
					ScreenService.showMessage(succes);
				}
			}.bind(this), function(error) {
				ScreenService.showMessage(error.data.error);
			});
		}
	};
	
	this.validaFilialControlaAlmoxarifadoRetiradaEstoque = function() {
        var filtroWidget = EstUtil.getFilterWidget(templateManager.container.getWidget('retirada'));

        var cdfilial = filtroWidget.getField('CDFILIAL').value() || getLocalVar('CDFILIAL');

        Est58000_RetiradaEstoque_Service.retornaParamUnidadeRetiradaEstoque(cdfilial).then(function(paramfilial) {

            var filial = paramfilial.dataset.paramfilial[0];
            let filtroRow = filtroWidget.currentRow;
            const container = filtroWidget.getParent();
            const defaultFields = [];
            delete filial.CDOPERADOR;
            delete filial.CDALMOXARIFE;
            delete filial.CDLOCALESTOQ;
			
			

            sessionStorage.setItem('IDUTILALMOX', filial.IDUTILALMOX);
            sessionStorage.setItem('IDUTILLCESTQ', filial.IDUTILLCESTQ);
            sessionStorage.setItem('IDUTILLOTE', filial.IDUTILLOTE);
            sessionStorage.setItem('FILIAL_CTRLESTQE', filial.IDCTRLESTQ);

            if (filtroWidget.getField('DSALMOXARIFE')) {
                if (filial.IDUTILALMOX == 'S') {
                    filtroWidget.getField('DSALMOXARIFE').isVisible = true;
                }
                else {
                    filtroWidget.getField('DSALMOXARIFE').isVisible = false;
                }

                if (filial.IDUTILLCESTQ == 'S') {
                    filtroWidget.getField('DSLOCALESTOQ').isVisible = true;
                }
                else {
                    filtroWidget.getField('DSLOCALESTOQ').isVisible = false;
                }
                filtroWidget.getField('DSALMOXARIFE').reload();
            }
            filtroWidget.reload();

        });
    };

	/**
	 * Essa função tem como finalidade dar um newRow na widget de itens e com base nos
	 * dados que a mesma já tem, calcular qual será o próximo sequencial do item para
	 * aquela retirada de estoque.
	 * Antes disso é verificado se a retirada pode ser editada, verificando os capos NRORDPROD e
	 * NRLANCESTRET, onde se um deles estiver preencido, é dado sua respctiva mensagem, impedindo
	 * o usuário de editar a retirada.
	 *
	 * @param widget | widget de itens da retirada
	 */



	this.newItem = function(widget) {

		if (widget.getParent().currentRow.EXISTECONSUMO != 'S') {
			if (!widget.getParent().currentRow.NRORDPROD) {
				if (!widget.getParent().currentRow.NRLANCESTRET) {
					widget.newRow();
					widget.currentRow.novo = true;
					widget.currentRow.NRSEQUITEM = Est58000_RetiradaEstoque_Service.geraNrsequitem(widget.dataSource.data);
					widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTLANCESTQ;
				}
				else {
					ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
			}
		}
		else {
			ScreenService.showMessage("Operação bloqueada! Não é possivel adicionar item pois existe consumo.");
		}

	};

	/**
	 * Essa função tem a finalidade de validar a relação entre os valores dos campos de valor
	 * na widget de itens.
	 *
	 * @param widget | widget de itens
	 */
	this.onChangeQt = function(widget) {
		var row = widget.currentRow;
		var calcTotValues = true,
			isValid = false;
		var permitEstoqNeg = widget.getParent().currentRow.idpermestneg;
		if (row.QTDEVOLESTOQ < 0) {
			row.QTDEVOLESTOQ = null;
			ScreenService.showMessage('A quantidade devolvida não pode ser menor que 0.');
		}
		else if (row.QTTOTLANCTO <= 0) {
			row.QTTOTLANCTO = null;
			ScreenService.showMessage('A quantidade retirada não pode ser menor ou igual a 0.');
		}
		else if (row.QTTOTLANCTO < row.QTDEVOLESTOQ) {
			row.QTDEVOLESTOQ = null;
			ScreenService.showMessage('A quantidade retirada não pode ser menor que a quantidade devolvida.');
		}
		else if (row.QTTOTLANCTO > row.QTESTOQDIA && permitEstoqNeg == 'N') {
			ScreenService.showMessage('Quantidade informada não disponível no estoque.');
			row.QTTOTLANCTO = null;
		}
		else if (row.QTTOTLANCTO === row.QTDEVOLESTOQ) {
			calcTotValues = false;
			ScreenService.confirmMessage('Quantidade movimentada igual a 0, portanto o item não realizará atualização de estoque. Confirmar operação?',
				'question',
				function() { //sim
					Est58000_RetiradaEstoque_Service.setQtLanctoEst(row);
					Est58000_RetiradaEstoque_Service.setVrTotLancto(row);

					this.checkSaveProduto(widget, true);
				}.bind(this),
				function() { //não
					row.QTDEVOLESTOQ = null;
					Est58000_RetiradaEstoque_Service.setQtLanctoEst(row);
					Est58000_RetiradaEstoque_Service.setVrTotLancto(row);
				});
		}
		else {
			isValid = true;
		}

		if (calcTotValues) {
			Est58000_RetiradaEstoque_Service.setQtLanctoEst(row);
			Est58000_RetiradaEstoque_Service.setVrTotLancto(row);
		}

		return isValid;
	};

	this.openPosicaoDeEstoque = function(widget) {
		var popup = this.getPosicaoDeEstoquePopup(widget);

		ScreenService.openPopup(popup);

		popup.currentRow = widget.currentRow;
		popup.parentWidget = widget;

		this.getDataForPosicaoDeEstoquePopup(popup);
	};

	this.getDataForPosicaoDeEstoquePopup = function(popup) {
		Est58000_RetiradaEstoque_Service.getPosicaoDeEstoquePorProduto(popup.currentRow).then(function(posestdia) {
			if (posestdia) {
				popup.currentRow = posestdia;
				let qtToSet = posestdia.QTESTOQDIA;
				if (qtToSet == 'undefined' || qtToSet == null)
					qtToSet = 0;
				popup.parentWidget.currentRow.QTESTOQDIA = qtToSet;
			}
			else {
				popup.currentRow.QTESTOQDIA = 0;
			}
		}).catch(function(error) {
			ScreenService.showMessage(error.data.error);
		});
	};

	this.getPosicaoDeEstoquePopup = function(parentWidget) {
		var widget = parentWidget.posestPopup;

		if (!widget) {
			widget = this.getPosicaoDeEstoquePopUpObject();
			widget.container = parentWidget.container;
			widget.label = widget.defaultLabel + parentWidget.currentRow.NMPRODUTO;

			widget = metaDataFactory.widgetFactory(widget, parentWidget);

			parentWidget.posestPopup = widget;
			widget.parent = parentWidget;
		}
		else
			widget.label = widget.defaultLabel + parentWidget.currentRow.NMPRODUTO;

		return widget;
	};

	this.getPosicaoDeEstoquePopUpObject = function() {
		return {
			"name": "posestPopup",
			"defaultLabel": "Posição de Estoque do Produto ",
			"template": "widget/form.html",
			"isVisible": true,
			"showAsTab": false,
			"actions": [{
					"name": "back",
					"label": "Voltar",
					"showAsAction": "back",
					"isVisible": true,
					"events": [{
						"name": "ActionEvent",
						"code": "ScreenService.closePopup()"
					}]
				},
				{
					"name": "refresh",
					"label": "Atualizar",
					"showAsAction": "never",
					"isVisible": true,
					"events": [{
						"name": "ActionEvent",
						"code": "Est58000_RetiradaEstoque_Controller.getDataForPosicaoDeEstoquePopup(args.owner.widget)"
					}]
				}
			],
			"fields": [{
					"name": "CDALMOXARIFE",
					"label": "Almoxarifado",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
				},
				{
					"name": "CDLOCALESTOQ",
					"label": "Localização",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
				},
				{
					"name": "NRLOTEESTQ",
					"label": "Lote",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
				},
				{
					"name": "NRSUBLOTE",
					"label": "Sublote",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"events": []
				},
				{
					"name": "QTESTOQDIA",
					"label": "Quantidade",
					"isVisible": true,
					"readOnly": true,
					"template": "field/text-edit.html",
					"class": 6,
					"showOnForm": true,
					"mask": {
						"type": "viewFloat",
						"params": {
							"precision": 2,
							"showSymbol": false
						}
					},
					"events": []
				},
				{
					"name": "DTVALILOTE",
					"label": "Data de Validade",
					"isVisible": true,
					"sequenceInForm": 80,
					"readOnly": true,
					"defaultValue": null,
					"template": "field/calendar.html",
					"dateFormat": "DD/MM/YYYY",
					"class": 6,
					"showOnForm": true,
					"events": []
				}
			]
		};
	};

	/**
	 * Essa função tem a finalidade de ser executada quando o usuário quer remover um item de uma
	 * retirada que está sendo inserido, dessa forma é procurado em qual posição do data da widget
	 * está o item que o usuário quer retirar, e então é tirado do data da widget.
	 *
	 *	@param widget | widget de itens
	 */
	this.removeItemDataSource = function(widget) {
		var itens = widget.dataSource.data;
		for (var i = 0; i < itens.length; i++) {
			if (itens[i].CDARVPROD === widget.currentRow.CDARVPROD &&
				itens[i].CDALMOXARIFE === widget.currentRow.CDALMOXARIFE &&
				itens[i].CDLOCALESTOQ === widget.currentRow.CDLOCALESTOQ &&
				itens[i].NRLOTEESTQ === widget.currentRow.NRLOTEESTQ &&
				itens[i].NRSUBLOTE === widget.currentRow.NRSUBLOTE
			) {
				itens.splice(i, 1);
				i = itens.length;
				ScreenService.closeSwipe();
			}
		}
	};

	/**
	 * Inicialmente a função verifica se a retirada pode ser editada (inserir/excluir/editar um item
	 * é editar uma retirada), se tiver problema é dado uma mensagem na tela. Se tudo estiver certo,
	 * a função de excluir do General é chamada para excluir o item. Essa função é chamada quando
	 * se está excluindo um item de uma retirada que já existe.
	 *
	 * @param widget | widget de itens
	 */
	this.removeItemRetirada = function(widget) {
		if (widget.getParent().currentRow.NRLANCESTQSAID != null) {
			ScreenService.showMessage("Operação bloqueada! Lançamento vindo da tela de Processamento de Produtos, não pode ser alterado.");
		}
		else {
			if (!widget.getParent().currentRow.NRORDPROD) {
				if (!widget.getParent().currentRow.NRLANCESTRET) {
					if (widget.dataSource.data.length > 1) {
						General.deleteCrud(widget);
					}
					else {
						ScreenService.showMessage("Operação bloqueada! Não é possível existir uma retirada sem item.");
					}
				}
				else {
					ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
			}
			if (widget.getParent().currentRow.NRLANCESTQSAID != null) {
				ScreenService.showMessage("Operação bloqueada! Lançamento vindo da tela de Processamento de Produtos, não pode ser alterado.");
			}
		}
	};

	/**
	 *
	 *
	 * @param widget | widget de retirada
	 */
	this.removeRetirada = function(widget) {
		if (widget.currentRow.NRLANCESTQSAID != null) {
			ScreenService.showMessage("Operação bloqueada! Lançamento vindo da tela de Processamento de Produtos, não pode ser alterado.");
		}
		else {
			if (!widget.currentRow.NRORDPROD) {
				if (widget.currentRow.__is_new) {
					let filteredDataset = widget.dataSource.data.filter(row => row.__is_new == false);
					widget.dataSource.data = filteredDataset;
					ScreenService.closeSwipe();
				}
				else {
					if (!widget.currentRow.NRLANCESTRET) {
						General.deleteCrud(widget);
					}
					else {
						ScreenService.showMessage("Operação bloqueada! Retirada oriunda de um ajuste de inventário.");
					}
				}
			}
			else {
				ScreenService.showMessage("Operação bloqueada! Retirada gerada pela Ordem de Produção.");
			}
		}
	};

	/**
	 * Essa função tem como finalidade retornar todas as propriedades e labels de todas as widgets,
	 * para o estado normal da tela. Ela é chamado quando se termina ou cancela o processo de inserção
	 * de uma retirada.
	 *
	 * @param widget | widget de retirada
	 */
	this.returnStatus = function(widget) {
		//Mudanças na widget de Retirada para voltar ao estado de visualização
		widget.enabled = true;
		this.changeHideInconLabelVisible(widget.actions, 'Salvar', true, 'salvar', true);
		//Mudanças na widget de Itens para voltar ao estado de visualização
		var widgetItens = widget.widgets[0];
		widgetItens.enabled = true;
		this.changeHideInconLabelVisible(widgetItens.actions, 'Voltar', false, 'VoltarList', true);
		this.changeHideInconLabelVisible(widgetItens.actions, 'Salvar', true, 'salvarNaRetirada', false);
		widgetItens.floatingControl.refreshAction = true;
		widgetItens.call = 'padrão';
	};

	/**
	 * Essa função tem como finalidade salvar um produto novo em uma retirada já existente
	 * ou salvar a edição de um produto existente em uma retirada já existente. A função seta
	 * alguns campos da currentRow de itens com dados de referência da currentRow de retirada
	 * quando estiver inserindo um novo produto. Na sequência valida se essa operação não vai
	 * gerar estoque negativo e por fim chama a função de salvar do General.
	 *
	 */
	this.save = function(widgetRetirada) {
		var widgetItens = templateManager.container.getWidget('itens');
		var itens = widgetItens.currentRow;
		var lancamento = widgetRetirada.currentRow;
		if (widgetItens.currentRow.__is_new) {
			itens.NRREQUESTO = lancamento.NRREQUESTO;
			itens.NRLANCESTQ = lancamento.NRLANCESTQ;
			itens.CDTIPORETI = lancamento.CDTIPORETI;
			itens.CDCENTCUST = lancamento.CDCENTCUST;
			itens.DTLANCMOVI = lancamento.DTLANCESTQ;
			itens.CDPRODMOVI = itens.CDPRODUTO;
		}
		General.saveCrud(widgetItens).then(() => {
			widgetRetirada.reload();
			this.carregaItems(widgetRetirada);
		});
	};

	/**
	 * Essa função tem a finalidade de executar os processos da edição de uma retirada. Chamando
	 * a função de salvar da widget, e no sucesso deixando a widget no modo view e dando reload
	 * na widget filha.
	 *
	 * @param widget | widget de retirada
	 */
	this.saveEditRetirada = function(widget) {
		//if(widget.isValid()) {
		widget.saveRow().then(function() {
			widget.view();
			widget.widgets[0].enabled = true;
			widget.widgets[0].reload();
		}, function(error) {
			ScreenService.showMessage(error.data.error);
		});
		//}
	};

	/**
	 * Essa função tem a finalidade de salvar a retirada e executar as mudanças na widget pós
	 * salvamento. Para salvar é necessário que existam itens sendo inseridos junto à retirada
	 * e que os itens que estão sendo inseridos estejam com as informações completas (passado
	 * pela tela Informações Complementares de Produto).
	 *
	 * @param widget | widget de itens
	 */
	this.saveNewRetirada = function(widget) {
		var widgetRetirada = templateManager.container.getWidget('retirada');
		var itens = widget.dataSource.data;
		if (itens.length <= 0) {
			ScreenService.showMessage('É preciso adicionar itens à retirada para salva-la.');
		}
		else if (this.checkProdutosCompletos(itens)) {
			widgetRetirada.currentRow.ITENS = itens;
			ScreenService.showLoader();
			Est58000_RetiradaEstoque_Service.saveRetirada(widgetRetirada.currentRow).then(function(sucess) {
				var lancamento = sucess.dataset.lancamento[0];
				var parentCurrentRowIndex = widget.getParent().dataSource.data.indexOf(widget.getParent().currentRow);

				this.returnStatus(widget.getParent());

				lancamento.NMFILIAL = widget.getParent().appliedFilter.FILTER_ROW.NMFILIAL;

				widget.getParent().currentRow = lancamento;
				widget.getParent().currentRow.__is_new = false;
				widget.getParent().dataSource.data[parentCurrentRowIndex] = widget.getParent().currentRow;
				widget.getParent().view();

				widget.reload();
				widget.activate();
				ScreenService.hideLoader();
			}.bind(this), function(error) {
				if (error.dataset && error.dataset.irregularProducts) {
					let irregularProducts = error.dataset.irregularProducts;
					let dados = widget.dataSource.data;
					dados.forEach((d, index) => {
                            irregularProducts.forEach((irrProd)=>{
                                let expIsIrregular = d.CDPRODUTO == irrProd.cdproduto && d.NRLOTEESTQ == irrProd.nrloteestq && d.CDALMOXARIFE == irrProd.cdalmoxarife && d.NRSUBLOTE == irrProd.nrsublote && d.CDLOCALESTOQ == irrProd.cdlocalestoq;
                                if(expIsIrregular){
                                    d.IRREGULAR = true;
                                }
                            });
                        });
					widget.redraw();
				}else{
					if(error.error)
						error.data = {error: error.error};
				}
				ScreenService.showMessage(error.data.error);
				ScreenService.hideLoader();
			});
		}
	};

	this.saveNewRetiradaLeitor = function() {
		var widgetRetirada = templateManager.container.getWidget('retirada');
		var retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');

		if (!retiradaTabbed.isValid()) {
			return;
		}
		var itens = gridProdutosLeitor.dataSource.data;
		if (itens.length <= 0) {
			ScreenService.showMessage('É preciso adicionar itens à retirada para salva-la.');
		}
		else if (this.checkProdutosCompletos(itens)) {
			ScreenService.showLoader();
			if (gridProdutosLeitor.getParent().currentRow.NRLANCESTQ) {
				var itemClone = [...itens];
				itemClone.forEach(row => { 
					delete row.__rightActions; 
					EstUtil.fixEmptyStockLocals(row);
				});
				EstUtil.saveDataSetCrud(itemClone, 'itlanctoest').then((sucess) => {
						gridProdutosLeitor.dataSource.data.forEach(row => { row.__is_new = false; });
						var parentCurrentRowIndex = gridProdutosLeitor.getParent().dataSource.data.indexOf(gridProdutosLeitor.getParent().currentRow);
						this.returnStatus(gridProdutosLeitor.getParent());
						gridProdutosLeitor.currentRow.QTLANCTOEST = 1;
						gridProdutosLeitor.getParent().currentRow.__is_new = false;
						this.validaNewLancto();
						this.changeReadOnlyByName(gridProdutosLeitor, "QTTOTLANCTO", false);
						if (gridProdutosLeitor.currentRow.IDEVOLESTOQ == 'N') {
							this.atualizaEstoqueActionVisibility();
						}
						gridProdutosLeitor.getParent().dataSource.data[parentCurrentRowIndex] = gridProdutosLeitor.getParent().currentRow;
						
						gridProdutosLeitor.reload();
						gridProdutosLeitor.activate();
						ScreenService.hideLoader();
						widgetRetirada.reload();
					},
					(error) => {
						console.log(error);
					});
			}
			else {
				retiradaTabbed.currentRow.ITENS = Util.clone(itens);
				Est58000_RetiradaEstoque_Service.saveRetirada(retiradaTabbed.currentRow).then((sucess) => {
					var lancamento = sucess.dataset.lancamento[0];
					var parentCurrentRowIndex = gridProdutosLeitor.getParent().dataSource.data.indexOf(gridProdutosLeitor.getParent().currentRow);
					this.returnStatus(gridProdutosLeitor.getParent());
					lancamento.NMFILIAL = widgetRetirada.appliedFilter.FILTER_ROW.NMFILIAL;
					gridProdutosLeitor.getParent().currentRow = lancamento;
					gridProdutosLeitor.currentRow.QTLANCTOEST = 1;
					gridProdutosLeitor.getParent().currentRow.__is_new = false;
					this.validaNewLancto();
					this.changeReadOnlyByName(gridProdutosLeitor, "QTTOTLANCTO", false);
					if (gridProdutosLeitor.currentRow.IDEVOLESTOQ == 'N') {
						this.atualizaEstoqueActionVisibility();
					}
					gridProdutosLeitor.getParent().dataSource.data[parentCurrentRowIndex] = gridProdutosLeitor.getParent().currentRow;
					
					gridProdutosLeitor.reload();
					gridProdutosLeitor.activate();
					ScreenService.hideLoader();
					widgetRetirada.reload();
				}, function(error) {
					if (error.dataset && error.dataset.irregularProducts) {
						let irregularProducts = error.dataset.irregularProducts;
						let dados = gridProdutosLeitor.dataSource.data;
						dados.forEach((d, index) => {
			                irregularProducts.forEach((irrProd)=>{
			                    let expIsIrregular = d.CDPRODUTO == irrProd.cdproduto && d.NRLOTEESTQ == irrProd.nrloteestq && d.CDALMOXARIFE == irrProd.cdalmoxarife && d.NRSUBLOTE == irrProd.nrsublote && d.CDLOCALESTOQ == irrProd.cdlocalestoq;
			                    if(expIsIrregular){
			                        d.IRREGULAR = true;
			                    }
			                });
			            });
						var invalidProd = dados.filter(row => row.IRREGULAR);
						var validProd = dados.filter(row => !row.IRREGULAR);
						gridProdutosLeitor.dataSource.data = validProd;
						gridProdutosLeitor.redraw();
						ScreenService.showMessage(invalidProd[0].NMPRODUTO + ' IRREGULAR!');
						ScreenService.hideLoader();
						return 0;
					}
					ScreenService.showMessage(error.data.error);
					ScreenService.hideLoader();
				});
			}
			this.disparaAtualizaEstoque();
		}
	};


	/**
	 * Essa função tem como finalidade setar datas defaut para o filtro da tela conforme a
	 * data de processamento da filial selecionada, trocar a editabilidade do campo de
	 * almoxarifado conforme a parametrização da filial selecionada, e setar o nome e
	 * código da filial logada caso o evento estiver sendo chamado no início da tela.
	 * Depois chama a função para validar a regra dos campos de data.
	 *
	 * @param widget | widget do filtro
	 * @param array | recebe um array com código e nome da filial selecionada no filtro
	 * @param filial | codigo da filial para saber se seta ou não o campo de filial no filtro
	 */
	this.setCampos = function(widget, array, filial) {
		//Setando datas do campo Data
		var dtprocessa = Est58000_RetiradaEstoque_Service.getDtprocessa();
		var dtinicial = moment(dtprocessa, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
		widget.currentRow.DTINICIAL = dtinicial;
		widget.currentRow.DTFINAL = dtprocessa;
		if (!widget.currentRow.INTERVALO) {
			widget.currentRow.INTERVALO = {};
		}
		widget.currentRow.INTERVALO.start = dtinicial;
		widget.currentRow.INTERVALO.end = dtprocessa;
		//Habilitando Almoxarifado, reseta a currentRow e desabilita Localização
		if (Est58000_RetiradaEstoque_Service.utilizaAlmoraifado()) {
			widget.getField('DSLOCALESTOQ').readOnly = false;
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			widget.getField('DSALMOXARIFE').readOnly = false;
			widget.currentRow.CDALMOXARIFE = null;
			widget.currentRow.DSALMOXARIFE = null;
			widget.getField('DSALMOXARIFE').reload();
		}
		else {
			widget.getField('DSLOCALESTOQ').readOnly = true;
			widget.currentRow.CDLOCALESTOQ = null;
			widget.currentRow.DSLOCALESTOQ = null;
			widget.getField('DSALMOXARIFE').readOnly = true;
			widget.currentRow.CDALMOXARIFE = null;
			widget.currentRow.DSALMOXARIFE = null;
		}
		//Setando campo de filial se for no início da tela
		if (filial === 'FILIAL_LOGADA') {
			widget.currentRow.CDFILIAL = array[0];
			widget.currentRow.NMFILIAL = array[1];
		}
		this.setMinMaxAndRequired(widget);
	};

	/**
	 * Essa função tem como finalidade setar o código da filial que será inserida na retirada
	 * na row do novo item a ser inserido naquela retirada.
	 *
	 * @param widget | widget itens da retirada
	 */
	this.setCdfilimovi = function(widget) {
		var newRow = widget.currentRow;
		//newRow.CDFILIMOVI = widget.getParent().currentRow.CDFILIAL;
		newRow.CDFILIMOVI = EstUtil.getFieldValue('CDFILIAL', 'retirada', true);
	};

	/**
	 * Essa função tem como finalidade setar a filial e a data de lançamento quando é
	 * acionado o botão de adicionar uma retirada. É sugerida a filial que foi passada
	 * no filtro, e a data de lançamento é a data de processamento da filial. Depois
	 * chama uma função para desabilitar a aba de produtos, e outra para trocar a label
	 * do botão inferior direito da tela.
	 *
	 * @param widget | widget de retirada
	 */
	this.setCurrentRowNew = function(widget) {
		widget.currentRow.CDFILIAL = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		widget.currentRow.CDFILILANC = widget.appliedFilter.FILTER_ROW.CDFILIAL;
		widget.currentRow.NMFILIAL = widget.appliedFilter.FILTER_ROW.NMFILIAL;
		widget.currentRow.DTLANCESTQ = Est58000_RetiradaEstoque_Service.getDtprocessa();
		this.enabledWidget(false);
		this.changeHideInconLabelVisible(widget.actions, "Adicionar Produtos", true, "salvar", true);

		var widgetItens = templateManager.container.getWidget('itens');
		let impAction = widgetItens.getAction('importTxt');
		impAction.isVisible = widgetItens.dataSource.data.length == 0;
	};

	/**
	 * Essa função tem a finalidade de pegar os dois campos de data do filtro, e caso o
	 * valor deles seja null, em ambos, tira sua obrigatoriedade. Caso um deles tenha
	 * valor, é setado o max e min date de cada um com o valor do outro campo e ambos
	 * são colocados como obrigatórios. Dessa forma se um deles estiver com valor, ambos
	 * serão obrigatórios, mas se o usuário não quiser filtrar por data, e deixar ambos
	 * vazios, eles deixam de ser obrigatórios.
	 *
	 * @param widget | widget do filtro
	 */
	this.setMinMaxAndRequired = function(widget) {
		var fdateIni = widget.getField('DTINICIAL');
		var fdateFin = widget.getField('DTFINAL');

		if (!fdateIni.value() && !fdateFin.value()) {
			delete fdateIni.filterProperties.validations.required;
			delete fdateFin.filterProperties.validations.required;
		}
		else {
			fdateIni.filterProperties = { "validations": {} };
			fdateIni.filterProperties.maxDate = fdateFin.value();
			fdateIni.filterProperties.validations.required = true;

			fdateFin.filterProperties = { "validations": {} };
			fdateFin.filterProperties.minDate = fdateIni.value();
			fdateFin.filterProperties.validations.required = true;
		}
	};

	/**
	 * Essa função tem a finalidade de setar o campo de Valor Unitário do produto que foi selecionado
	 * na widget de itens. Para pegar esse valor é necessario exeutar uma função do banco de dados.
	 * O resultado da função é o valor unitário do produto e sua quantidade em estoque. Ambos os valores
	 * são colocados na currentRow da widget.
	 *
	 * @param widget | widget de itens
	 */
	//Mexer Aqui!
	this.setValorUnitario = function(widget) {
		var deffer = ZHPromise.defer();
		Est58000_RetiradaEstoque_Service.getCdtipocusto(widget.currentRow.CDFILIAL).then(function(cdtipocusto) {
			widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTLANCESTQ;
			Est58000_RetiradaEstoque_Service.setBlankLocalEstFields(widget);
			ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
				widget.currentRow.CDFILIAL,
				widget.currentRow.CDPRODUTO,
				widget.currentRow.DTLANCMOVI.substr(0, 10),
				cdtipocusto,
				widget.currentRow.CDALMOXARIFE,
				widget.currentRow.CDLOCALESTOQ,
				widget.currentRow.NRLOTEESTQ,
				widget.currentRow.NRSUBLOTE
			).then(function(success) {
				var consulta = success.dataset.consultaCustoQuantidadeProduto;
				widget.currentRow.QTESTOQDIA = consulta.QTESTOQDIA;
				widget.currentRow.VRUNILANCTO = consulta.VRCUSTOPROD;
				Est58000_RetiradaEstoque_Service.setVrTotLancto(widget.currentRow);
				widget.currentRow.COMPLETO = 'S';
				deffer.resolve();
			}, function(error) {
				ScreenService.showMessage(error.data.error);
				deffer.reject();
			});
		}, function(error) {
			ScreenService.showMessage(error.data.error);
			deffer.reject();
		});
		return deffer;
	};

	/**
	 * Essa função tem a finalidade de mudar a data de lançamento durante a inserção
	 * de uma nova retirada. É verificada a data de processamento da filial que o
	 * usuário selecionou.
	 *
	 * @param widget | widget de retirada, no modo de inserção (swipe)
	 */
	//Mexer Aqui!
	this.suggestDtprocessa = function(widget) {
		var cdfilial = widget.currentRow.CDFILIAL;
		Est58000_RetiradaEstoque_Service.getParamFilial(cdfilial, false).then(function(succes) {
			if (typeof succes === 'string') {
				ScreenService.showMessage(succes);
			}
			else {
				widget.currentRow.DTLANCESTQ = succes.DTPROCESSA;
			}
		}, function(error) {
			ScreenService.showMessage(error.data.error);
		});
	};

	//Mexer Aqui!
	this.loadDataSource = function(widget) {
		widget.getField('DSALMOXARIFE').dataSourceFilter.forEach(function(fil) {
			if (fil.name === 'CDFILIAL') {
				fil.value = widget.currentRow.CDFILIAL;
			}
		});

		widget.getField('DSLOCALESTOQ').dataSourceFilter.forEach(function(fil) {
			if (fil.name === 'CDFILIAL') {
				fil.value = widget.currentRow.CDFILIAL;
			}
		});

		widget.getField('DSREQUESTO').dataSourceFilter.forEach(function(fil) {
			if (fil.name === 'CDFILIAL') {
				fil.value = widget.currentRow.CDFILIAL;
			}
		});

		widget.getField('DSALMOXARIFE').reload();
		widget.getField('DSLOCALESTOQ').reload();
		widget.getField('DSREQUESTO').reload();

		this.getFilialLogada(widget.currentRow.CDFILIAL).then((success) => {
			if (success.dataset.paramfilial_paramvalidacoes.length > 0) {
				let returnedDataset = success.dataset.paramfilial_paramvalidacoes[0];
				this.filialctrlestoq = returnedDataset.IDCTRLESTQ;
				if (this.filialctrlestoq == 'S' ? false : true)
					ScreenService.showMessage('Filial não Controla Estoque');
			}
		});

	};
	//Mexer Aqui!
	this.actViewStockVisibility = function(args) {
		let widget = {};
		if (args.owner.container)
			widget = args.owner.container.getWidget('itens');
		else
			widget = args.owner.field.widget;
		if (widget.currentRow.CDPRODUTO)
			widget.getAction('viewstock').isVisible = true;
		else
			widget.getAction('viewstock').isVisible = false;
	};

	var isset = (accessor) => {
		try {
			// Note we're seeing if the returned value of our function is not
			// undefined
			return typeof accessor() !== 'undefined' && accessor() !== null;
		}
		catch (e) {
			// And we're able to catch the Error it would normally throw for
			// referencing a property of undefined
			return false;
		}
	};

	this.openAnexoSwipe = function(widget) {
		let widgetImportTxt = templateManager.container.getWidget('wdgUploadTxt');
		let retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		let widgetProdutos = templateManager.container.getWidget('itens');
		let widgetRetirada = templateManager.container.getWidget('retirada');
		let gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');
		
		const isRetirada = true;

		if (widget.name === widgetProdutos.name) {
			widgetImportTxt.isVisible = true;
			this.onManageXlsModelFields(isRetirada).then(function () {
                ScreenService.openSwipe(widgetImportTxt).then(function () {
                    widgetImportTxt.newRow();
                });
            });
		}
		if (widget.name === widgetRetirada.name) {
			retiradaTabbed.isVisible = true;
			retiradaTabbed.currentRow.__is_new = true;
			retiradaTabbed.currentRow.DTLANCESTQ = "";
			retiradaTabbed.currentRow.NMSETOR = "";
			retiradaTabbed.currentRow.NMTIPORETI = "";
			retiradaTabbed.currentRow.DSLANCESTQ = "";
			gridProdutosLeitor.getAction('salvarNaRetirada').isVisible = false;

			this.changeReadOnlyByName(retiradaTabbed, "DTLANCESTQ", false);
			this.changeReadOnlyByName(retiradaTabbed, "NMSETOR", false);
			this.changeReadOnlyByName(retiradaTabbed, "NMTIPORETI", false);
			this.changeReadOnlyByName(retiradaTabbed, "DSLANCESTQ", false);

			ScreenService.openSwipe(retiradaTabbed);

			gridProdutosLeitor.activate();
		}

	};

	//Mexer Aqui!
	this.closeAnexoSwipe = function(widget) {
		let widgetItens = templateManager.container.getWidget('itens');
		widgetItens.activate();
		ScreenService.closeSwipe();
	};
	
	this.onManageXlsModelFields = function(isAjuste = true) {
        return new Promise((resolve, reject) => {

            const modelXlsWidget = templateManager.container.getWidget('importaCamposXLS');
            modelXlsWidget.isVisible = true;
            const uploadWidget = templateManager.container.getWidget('wdgUpload');

            const almoxField = modelXlsWidget.getField('CDALMOXARIFE');
            const localField = modelXlsWidget.getField('CDLOCALESTOQ');
            const loteField = modelXlsWidget.getField('NRLOTEESTQ');
            const subLoteField = modelXlsWidget.getField('NRSUBLOTE');
            const dtValiLote = modelXlsWidget.getField('DTVALILOTE');
            const priceField = modelXlsWidget.getField('VRUNILANCTO');
            const dtFabField = modelXlsWidget.getField('DTFABRPROD');
            const dtValiField = modelXlsWidget.getField('DTVALILOTE');
            const cdProdutoField = modelXlsWidget.getField('CDPRODUTO');
            const cdArvProdField = modelXlsWidget.getField('CDARVPROD');
            const cdBarProdField = modelXlsWidget.getField('CDBARPRODUTO');
            const qtLancField = modelXlsWidget.getField('QTTOTLANCTO');

            const codProdTypesVisibility = {
                'C': () => cdProdutoField.isVisible = true,
                'A': () => cdArvProdField.isVisible = true,
                'B': () => cdBarProdField.isVisible = true,
                notVisible: () => {
                    cdProdutoField.isVisible = false;
                    cdArvProdField.isVisible = false;
                    cdBarProdField.isVisible = false;
                }
            };
            const widgetName = "retirada";
            const codigoFilial = EstUtil.getFieldValue('CDFILIAL', widgetName, true);

            this.getParamsImpEstRetirada(codigoFilial).then(response => {
                if (response.length > 0) {
                    uploadWidget.currentRow.PARAMS = response[0];

                    codProdTypesVisibility.notVisible();
                    codProdTypesVisibility[response[0].IDTIPOPRODPAR]();

                    almoxField.isVisible = sessionStorage.getItem('IDUTILALMOX') == 'S' ? true : false;
                    localField.isVisible = sessionStorage.getItem('IDUTILLCESTQ') == 'S' ? true : false;
                    loteField.isVisible = sessionStorage.getItem('IDUTILLOTE') == 'S' ? true : false;
                    subLoteField.isVisible = sessionStorage.getItem('IDUTILLOTE') == 'S' ? true : false;
					dtValiLote.isVisible = sessionStorage.getItem('IDUTILLOTE') == 'S' ? false : false;
                   

                    templateManager.updateTemplate();
                    resolve(true);

                }
                else {
                    ScreenService.hideLoader();
                    ScreenService.showMessage("Parâmetros para importação de estoque não encontrados.");
                }
            }).catch(error => {
                if (error.data)
                    ScreenService.showMessage(error.data.error);
                else
                    ScreenService.showMessage(error);
                ScreenService.hideLoader();
                reject(false);
            });
        });
    };
    
    this.getParamsImpEstRetirada = function(CDFILIMOVI) {
        return new Promise((resolve) => {
            General.callRestEngine('est_ajuste#/crud/paramimpest_params_codebar', 'FilterData', []).then(paramsData => {
                let hasDefaultParams = paramsData.dataset.paramimpest_params_codebar.filter(row => {
                    return row.IDFILIPADIMPEST == 'S';
                });

                if (hasDefaultParams.length == 0) {
                    return resolve(
                        paramsData.dataset.paramimpest_params_codebar.filter(row => {
                            return row.CDFILPARIMPEST === CDFILIMOVI;
                        })
                    );
                }
                else {
                    return resolve(hasDefaultParams);
                }
            });
        });

    };
    
    

	this.importarProdutosTxt = function(widget) {

		if (!widget.isValid()) {
			return;
		}
		
		var widgetItens = templateManager.container.getWidget('itens');
		var widgetRetirada = templateManager.container.getWidget('retirada');
		var ignoredKeys = ["__rightActions", "__createdLocal", "__index", "$error"];
		var file = widget.currentRow.ARQUIVOTXT;
		var modelXlsWidget = templateManager.container.getWidget('importaCamposXLS');

		widget.isVisible = false;
		ScreenService.closeSwipe().then(() => {
			widget.currentRow.CDFILIAL = widgetRetirada.currentRow.CDFILIAL;
			widget.currentRow.DTLANCESTQ = widgetRetirada.currentRow.DTLANCESTQ;
			widget.currentRow.CONTAINER = widget.container.name;
			widget.currentRow.CDFILIMOVI = widgetRetirada.appliedFilter.FILTER_ROW.CDFILIAL;
			this.getParamsImpEst(widget.currentRow.CDFILIMOVI).then(response => {
				if (response.dataset.paramimpest_params_codebar.length > 0) {
					widget.currentRow.PARAMS = response.dataset.paramimpest_params_codebar[0];
					widget.currentRow.ARQUIVOTXT = widget.getParent().currentRow.ARQUIVOTXT;
					widget.currentRow.PARAMS = widget.getParent().currentRow.PARAMS;
					
					if (!widget.currentRow.ARQUIVOTXT[0].type.includes('text/plain')) {
		                let file = widget.currentRow.ARQUIVOTXT;
		                let pos = file[0].b64File.indexOf(',') + 1;
		
		                widget.currentRow.CAMPOS = modelXlsWidget.fields.filter(field => field.isVisible == true).map(field => field.name);
		                widget.currentRow.FILE = {
		                    'name': file[0].name,
		                    'content': file[0].b64File.substr(pos)
		                };
		            }
		            
					Est58000_RetiradaEstoque_Service.importarProdutosTxt(Util.clone(widget.currentRow, ignoredKeys)).then(success => {
						var itens = success.dataset.itensRetirada;
						var itensDataSource = widgetItens.dataSource;
						var itensErrors = success.dataset.itensWithErrors;
						const popupErrosRetirada = templateManager.container.getWidget('PopUpErrosImportacaoRetirada');
						
						if(itensErrors.length > 0){
							popupErrosRetirada.dataSource.data = itensErrors;
							ScreenService.openPopup(popupErrosRetirada);
						}
						
							if (itens.length > 0) {
							widgetRetirada.currentRow.DTLANCESTQ = itens[0].DTLANCESTQ;
							itensDataSource.data = itens;

							itensDataSource.data.forEach((row) => {
								row.NRSEQUITEM = Est58000_RetiradaEstoque_Service.geraNrsequitem(itensDataSource.data);
								row.__is_new = true;
								row.changed = true;

								Est58000_RetiradaEstoque_Service.getCdtipocusto(row.CDFILIAL).then(function(cdtipocusto) {
									row.DTLANCMOVI = widgetRetirada.currentRow.DTLANCESTQ;

									if (!row.CDALMOXARIFE) row.CDALMOXARIFE = ' ';
									if (!row.CDLOCALESTOQ) row.CDLOCALESTOQ = ' ';
									if (!row.NRLOTEESTQ) row.NRLOTEESTQ = ' ';
									if (!row.NRSUBLOTE) row.NRSUBLOTE = ' ';
									if (!row.QTDEVOLESTOQ) row.QTDEVOLESTOQ = 0;

									ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
										row.CDFILIAL,
										row.CDPRODUTO,
										row.DTLANCMOVI.substr(0, 10),
										cdtipocusto,
										row.CDALMOXARIFE,
										row.CDLOCALESTOQ,
										row.NRLOTEESTQ,
										row.NRSUBLOTE
									).then(function(success) {
										var consulta = success.dataset.consultaCustoQuantidadeProduto;
										row.QTESTOQDIA = consulta.QTESTOQDIA;
										row.VRUNILANCTO = consulta.VRCUSTOPROD;
										Est58000_RetiradaEstoque_Service.setVrTotLancto(row);
										row.COMPLETO = 'S';
									});
								});
							});

							let impAction = widgetItens.getAction('importTxt');
							impAction.isVisible = widgetItens.dataSource.data.length == 0;

						}
						else {
							//ScreenService.showMessage("Não foram encontrados nenhum produto a partir do arquivo");
						}
					}).catch(error => {
						if (error.data) {
							if (error.data.errorCode == 400) {
								ScreenService.closeSwipe().then(() => {
									let impAction = widget.getParent().getAction("importTxt");
									this.openAnexoSwipe(impAction);
									ScreenService.showMessage(error.data.error);
								});
							}
							else {
								ScreenService.showMessage(error.data.error);
							}
						}
						else {
							ScreenService.showMessage(error);
						}

					});
				}
				else {
					ScreenService.showMessage("Parâmetros para importação de estoque não encontrados.");
				}
			}).catch(error => {
				if (error.data) {
					ScreenService.showMessage(error.data.error);
				}
				else {
					ScreenService.showMessage(error);
				}
			});
		});
	};

	this.getParamsImpEst = function(cdfilial) {
		var filter = [{
			"name": "CDFILPARIMPEST",
			"operator": "=",
			"value": cdfilial
		}];
		return General.callRestEngine('est_ajuste#/crud/paramimpest_params_codebar', 'FilterData', filter);
	};

	this.atualizarEstoque = function(widget) {
		let cdfilial = widget.getParent().currentRow.CDFILIAL;
		let nrlancestq = widget.getParent().currentRow.NRLANCESTQ;

		ValidacoesEstoque_Service.atualizaEstoque(cdfilial, nrlancestq, true).then(function(response) {
			widget.reload();
		}, function(error) {
			let irregularProducts = error.dataset.irregularProducts;
			let dados = widget.dataSource.data;
			dados.forEach((d, index) => {
                irregularProducts.forEach((irrProd)=>{
                    let expIsIrregular = d.CDPRODUTO == irrProd.cdproduto && d.NRLOTEESTQ == irrProd.nrloteestq && d.CDALMOXARIFE == irrProd.cdalmoxarife && d.NRSUBLOTE == irrProd.nrsublote && d.CDLOCALESTOQ == irrProd.cdlocalestoq;
                    if(expIsIrregular){
                        d.IRREGULAR = true;
                    }
                });
            });
			widget.redraw();
			ScreenService.showMessage(error.data.error);

		});
		widget.getAction('atualizaEstoque').isVisible = false;

		//return General.callRestEngine('est#/crud/confereRetiradaAjuste', 'Row', row);
	};

	this.atualizarEstoqueAutomatico = function(widget) {
		let cdfilial = widget.getParent().currentRow.CDFILIAL;
		let nrlancestq = widget.getParent().currentRow.NRLANCESTQ;

		ValidacoesEstoque_Service.atualizaEstoque(cdfilial, nrlancestq, true).then(function(response) {
			widget.reload();
		}, function(error) {
			let irregularProducts = error.dataset.irregularProducts;
			let dados = widget.dataSource.data;
			dados.forEach((d, index) => {
                irregularProducts.forEach((irrProd)=>{
                    let expIsIrregular = d.CDPRODUTO == irrProd.cdproduto && d.NRLOTEESTQ == irrProd.nrloteestq && d.CDALMOXARIFE == irrProd.cdalmoxarife && d.NRSUBLOTE == irrProd.nrsublote && d.CDLOCALESTOQ == irrProd.cdlocalestoq;
                    if(expIsIrregular){
                        d.IRREGULAR = true;
                    }
                });
            });
			widget.redraw();
			ScreenService.showMessage(error.data.error);

		});
		widget.getAction('atualizaEstoque').isVisible = false;

		//return General.callRestEngine('est#/crud/confereRetiradaAjuste', 'Row', row);
	};

	this.atualizaEstoqueActionVisibility = function() {
		var widget = templateManager.container.getWidget('gridProdutosLeitor');
		widget.getAction('atualizaEstoque').isVisible = widget.dataSource.data.some(row => row.IDEVOLESTOQ == 'N');

		var widgetProduto = templateManager.container.getWidget('itens');
		widgetProduto.getAction('atualizaEstoque').isVisible = widgetProduto.dataSource.data.some(row => row.IDEVOLESTOQ == 'N');

	};

	this.setActionAtualizaEstoqueInvisible = function(widget) {
		widget.getAction('atualizaEstoque').isVisible = false;
	};

	this.addNewRetiradaViaLeitor = function() {
		var widgetRetirada = templateManager.container.getWidget('retirada');
		var retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');

		retiradaTabbed.activate();
		retiradaTabbed.call = 'insertRetirada';
		retiradaTabbed.currentRow.CDFILIAL = widgetRetirada.appliedFilter.FILTER_ROW.CDFILIAL;
		retiradaTabbed.currentRow.CDFILILANC = widgetRetirada.appliedFilter.FILTER_ROW.CDFILIAL;
		retiradaTabbed.currentRow.NMFILIAL = widgetRetirada.appliedFilter.FILTER_ROW.NMFILIAL;
		retiradaTabbed.currentRow.DTLANCESTQ = Est58000_RetiradaEstoque_Service.getDtprocessa();
	};

	this.validaNewLancto = function() {
		var retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');
		var items = gridProdutosLeitor.currentRow;
		var lancto = retiradaTabbed.currentRow;

		if (!retiradaTabbed.currentRow.__is_new) {
			retiradaTabbed.currentRow.CDBARPRODUTO = "";
			retiradaTabbed.currentRow.NMPRODUTO = "";
			this.changeReadOnlyByName(retiradaTabbed, "CDBARPRODUTO", false);
			this.changeReadOnlyByName(retiradaTabbed, "NMPRODUTO", false);
			this.setRetirada(retiradaTabbed);
		}
		else {
			this.habilitaCdBarraProd(retiradaTabbed);
		}
	};

	this.habilitaCdBarraProd = function(retiradaTabbed) {
		if (!retiradaTabbed.isValid()) {
			return;
		}
		this.changeReadOnlyByName(retiradaTabbed, "CDBARPRODUTO", false);
		this.changeReadOnlyByName(retiradaTabbed, "NMPRODUTO", false);
		this.setRetirada(retiradaTabbed);
	};

	this.setRetirada = function(retiradaTabbed) {
		var widgetRetirada = templateManager.container.getWidget('retirada');
		retiradaTabbed.currentRow.CDFILIMOVI = widgetRetirada.appliedFilter.FILTER_ROW.CDFILIAL;
		retiradaTabbed.currentRow.DTLANCMOVI = retiradaTabbed.currentRow.DTLANCESTQ;
		retiradaTabbed.currentRow.QTTOTLANCTO = "";
		retiradaTabbed.currentRow.QTDEVOLESTOQ = "";
		retiradaTabbed.currentRow.NRREQUESTO = "";

		if (retiradaTabbed.currentRow.CDTIPORETI) {
			widgetRetirada.currentRow = retiradaTabbed.currentRow;
		}
	};

	this.blockHeaderInf = function() {
		var retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');

		if (!retiradaTabbed.isValid()) {
			return;
		}

		this.changeReadOnlyByName(retiradaTabbed, "DTLANCESTQ", true);
		this.changeReadOnlyByName(retiradaTabbed, "NMSETOR", true);
		this.changeReadOnlyByName(retiradaTabbed, "NMTIPORETI", true);
		this.changeReadOnlyByName(retiradaTabbed, "DSLANCESTQ", true);

	};

	this.InputCdBarraProd = function() {
		var retiradaTabbed = templateManager.container.getWidget('retiradaTabbedLeitor');
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');

		if (!retiradaTabbed.isValid()) {
			return;
		}
		gridProdutosLeitor.activate();
		
		// Verifica se NMPRODUTO ta disponivel e usa se tiver, senao usa CDBARPRODUTO
	    var verificaParametro = !!retiradaTabbed.currentRow.CDBARPRODUTO;

		this.getProd(verificaParametro, retiradaTabbed.currentRow.CDFILIAL, retiradaTabbed.currentRow).then(response => {
			if (response.dataset.prodfili_produto_cdbarraprod.length > 0) {
				var item = response.dataset.prodfili_produto_cdbarraprod[0];
				retiradaTabbed.currentRow.CDARVPROD = item.CDARVPROD;
				retiradaTabbed.currentRow.NMPRODUTO = item.NMPRODUTO;
				retiradaTabbed.currentRow.SGUNIDADE = item.SGUNIDADE;
				retiradaTabbed.currentRow.CDPRODUTO = item.CDPRODUTO;
				retiradaTabbed.currentRow.CDPRODESTO = item.CDPRODESTO;
				retiradaTabbed.currentRow.VRFATOCONV = item.VRFATOCONV;
				retiradaTabbed.currentRow.NRSEQUITEM = Est58000_RetiradaEstoque_Service.geraNrsequitem(gridProdutosLeitor.dataSource.data);
				retiradaTabbed.currentRow.QTTOTLANCTO = 1;
				retiradaTabbed.currentRow.QTLANCTOEST = retiradaTabbed.currentRow.QTTOTLANCTO * retiradaTabbed.currentRow.VRFATOCONV;
				retiradaTabbed.currentRow.CDPRODMOVI = retiradaTabbed.currentRow.CDPRODESTO;
				retiradaTabbed.currentRow.IDEVOLESTOQ = 'N';

				var promise = ZHPromise.defer();
				retiradaTabbed.promise = promise;

				Lib00206_InfComplProduto_Controller.infComplementares(retiradaTabbed, retiradaTabbed.currentRow);
				promise.then(response => {
					if (retiradaTabbed.currentRow.COMPLETO !== 'S') {
						this.clearRowItens(gridProdutosLeitor, false);
					}

					this.setValorUnitario(retiradaTabbed).then(afterGetCusto => {
						if (!retiradaTabbed.currentRow.__is_new) {
							retiradaTabbed.currentRow.IDTIPOMOVI = '3';
							retiradaTabbed.currentRow.IDORCEMCLC = '9';
							gridProdutosLeitor.currentRow.NRREQUESTO = retiradaTabbed.currentRow.NRREQUESTO;
							gridProdutosLeitor.currentRow.NRLANCESTQ = retiradaTabbed.currentRow.NRLANCESTQ;
							gridProdutosLeitor.currentRow.CDTIPORETI = retiradaTabbed.currentRow.CDTIPORETI;
							gridProdutosLeitor.currentRow.CDCENTCUST = retiradaTabbed.currentRow.CDCENTCUST;
							gridProdutosLeitor.currentRow.DTLANCMOVI = retiradaTabbed.currentRow.DTLANCESTQ;
							gridProdutosLeitor.currentRow.CDPRODMOVI = gridProdutosLeitor.currentRow.CDPRODESTO;
							gridProdutosLeitor.currentRow.QTLANCTOEST = gridProdutosLeitor.currentRow.QTTOTLANCTO;
						}
						retiradaTabbed.currentRow.VRLANCTOEST = retiradaTabbed.currentRow.VRUNILANCTO;
						retiradaTabbed.currentRow.VRLANCTOBRUT = retiradaTabbed.currentRow.VRUNILANCTO;
						var rowClone = Util.clone(retiradaTabbed.currentRow, ['__rightActions']);
						rowClone.__is_new = true;
						gridProdutosLeitor.dataSource.data.push(rowClone);
						gridProdutosLeitor.currentRow = retiradaTabbed.currentRow;
						gridProdutosLeitor.currentRow.__is_new = true;
						this.saveNewRetiradaLeitor();
					});
				});
			}
		}).catch(error => {
			if (error.data) {
				ScreenService.showMessage(error.data.error);
			}
			else {
				ScreenService.showMessage(error);
			}
		});
	};

	this.getProd = function(buscaParametro, cdFilial, row) {
		var filter = [{
				"name": buscaParametro ? "CDBARPRODUTO" : "CDPRODUTO",
				"operator": "=",
				"value": row[buscaParametro ? "CDBARPRODUTO" : "CDPRODUTO"]
			},
			{
				"name": "CDNVPRODUTO",
				"operator": "=",
				"value": General.getLevelByMask('GER_CDPICTPROD',1).length
			},
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": cdFilial
			},
			{
				"name": "IDPRODATIV",
				"operator": "=",
				"value": "A"
			},
			{
				"name": "IDPRODATIVPR",
				"operator": "=",
				"value": "S"
			},
			{
				"name": "IDCNTRESTOQ",
				"operator": "=",
				"value": "S"
			},
			{
				"name": "CDARVPROD|NMPRODUTO",
				"operator": "LIKE_ALL",
				"value": "%%"
			}
		];
		return General.callRestEngine('est#/crud/prodfili_produto_cdbarraprod', 'FilterData', filter);
	};

	this.changeQtProductViaLeitor = function() {
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');
		gridProdutosLeitor.currentRow.IDEVOLESTOQ = 'N';
		gridProdutosLeitor.currentRow.QTTOTLANCTO = gridProdutosLeitor.currentRow.QTTOTLANCTO_inline || gridProdutosLeitor.currentRow.QTTOTLANCTO;
		gridProdutosLeitor.currentRow.QTLANCTOEST = gridProdutosLeitor.currentRow.QTTOTLANCTO;
		gridProdutosLeitor.currentRow.VRTOTLANCTO = gridProdutosLeitor.currentRow.VRUNILANCTO * gridProdutosLeitor.currentRow.QTLANCTOEST;
		gridProdutosLeitor.currentRow.VRLANCTOEST = gridProdutosLeitor.currentRow.VRUNILANCTO * gridProdutosLeitor.currentRow.QTLANCTOEST;
		gridProdutosLeitor.currentRow.VRLANCTOBRUT = gridProdutosLeitor.currentRow.VRUNILANCTO * gridProdutosLeitor.currentRow.QTLANCTOEST;
		gridProdutosLeitor.currentRow.changed = true;

		var itensChanged = [...gridProdutosLeitor.dataSource.data];
		itensChanged.forEach(row => { delete row.__rightActions; });
		EstUtil.saveDataSetCrud(gridProdutosLeitor.dataSource.data, 'itlanctoest').then((sucess) => {

			},
			(error) => {
				console.log(error);
			});
		this.disparaAtualizaEstoque();
		this.atualizaEstoqueActionVisibility();

	};

	this.disparaAtualizaEstoque = function() {
		var gridProdutosLeitor = templateManager.container.getWidget('gridProdutosLeitor');
		var interval = setInterval((intervalTimeout) => {
			var widgetFilter = templateManager.container.getActiveWidget();
			if (widgetFilter.name == 'gridProdutosLeitor') {
				if (gridProdutosLeitor.dataSource.data.some(row => row.IDEVOLESTOQ == 'N')) {
					this.atualizarEstoqueAutomatico(gridProdutosLeitor);
				}
				else {
					clearInterval(interval);
				}
			}
			else {
				clearInterval(interval);
			}
		}, 600000);

	};

	this.timeOutReset = function() {
		var intervalo = setInterval(function(intervalTimeout) {
			var widgetFilter = templateManager.container.getActiveWidget();
			if (templateManager.container.name == 'est58000_retirada_estoque') {
				General.callRestEngine('est#/crud/paramgeral', 'FilterData', []);
			}
			else {
				clearInterval(intervalo);
			}
		}, 600000);
	};
}
Configuration(function(ContextRegister) {
	ContextRegister.register('Est58000_RetiradaEstoque_Controller', Est58000_RetiradaEstoque_Controller);
});
