function Est31250_produtos_nao_atualizados_Controller(General, restEngine, ScreenService, ProdTreeGroup, ZhFilterPreferences, templateManager, EstUtil, MessageService) {
    const orderby = "CDFILIAL, CDPRODMOVIEST, DTLANCMOVIEST, IDTIPOMOVIEST, NRLANCMOVIEST, NRSEQUMOVIEST";
    
    this.checkUnidadeField = function(widget) {
        var currentRow = widget.currentRow;

        if(currentRow.REPORT_NAME === 'Est31250IrrEstoque') {
            var almoxarifadoField = widget.getField('DSALMOXARIFE');
            var localestoqueField = widget.getField('DSLOCALESTOQ');

            if(currentRow.CDFILIAL) {
                    var filter = [
                        {
                            "name": "CDFILIAL",
                            "operator": "=",
                            "value": currentRow.CDFILIAL
                        }
        		    ];
                    General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then(validation => {
                    currentRow.ALMOXARIFADO = validation.dataset.paramfilial[0].IDUTILALMOX == 'S' ? validation.dataset.paramfilial[0].IDUTILALMOX : null;
                    currentRow.LOCALESTOQUE = validation.dataset.paramfilial[0].IDUTILLCESTQ == 'S' ? validation.dataset.paramfilial[0].IDUTILLCESTQ : null;
                    if(currentRow.ALMOXARIFADO) {
                        almoxarifadoField.dataSourceFilter[1] = 
                        {
                            "name": "CDFILIAL", 
                            "operator": "=", 
                            "value": currentRow.CDFILIAL
                        };
                        almoxarifadoField.readOnly            = false;
                        almoxarifadoField.validations         = {"required": true};

                        if(currentRow.LOCALESTOQUE) {
                            localestoqueField.dataSourceFilter[1] = 
                            {
                                "name": "CDFILIAL",
                                "operator": "=", 
                                "value": currentRow.CDFILIAL
                            };
                            localestoqueField.readOnly = false;
                            localestoqueField.validations = {"required": true};

                            this.checkAlmoxariFields(widget, true);
                        } else {
                            localestoqueField.readOnly    = true;
                            localestoqueField.validations = null;
                        }
                    } else {
                        almoxarifadoField.readOnly    = true;
                        almoxarifadoField.validations = null;

                        localestoqueField.readOnly    = true;
                        localestoqueField.validations = null;
                    }
                });
            } else {
                currentRow.ALMOXARIFADO = false;
                currentRow.LOCALESTOQUE = false;

                almoxarifadoField.readOnly = true;
                localestoqueField.readOnly = true;

                almoxarifadoField.validations = null;
                localestoqueField.validations = null;

                reloadFields(widget, true, true);
            }
        }
    };


    this.abrefiltro = function(args){
        var widget = args.owner;
        ZhFilterPreferences.openFilterWidget(widget, []);
    };

    this.checkAlmoxariFields = function(widget, flag) {
        var currentRow = widget.currentRow;

        if(currentRow.ALMOXARIFADO == 'S' && currentRow.LOCALESTOQUE) {
            widget.getField('DSLOCALESTOQ').readOnly = false;
            widget.getField('DSLOCALESTOQ').dataSourceFilter[2] = 
                {
                    "name": "CDALMOXARIFE", 
                    "operator": "=", 
                    "value": currentRow.CDALMOXARIFE
                };
        } else widget.getField('DSLOCALESTOQ').readOnly = true;

        if(flag) reloadFields(widget, true, true);
        else reloadFields(widget, false, true);
    };

    function reloadFields(widget, almoxarifado, localestoque) {
        var currentRow = widget.currentRow;

        if(almoxarifado) {
            currentRow.CDALMOXARIFE = (currentRow.ALMOXARIFADO)? null : ' ';
            currentRow.DSALMOXARIFE = (currentRow.ALMOXARIFADO)? null : ' ';

            widget.getField('DSALMOXARIFE').reload();
        }

        if(localestoque) {
            currentRow.CDLOCALESTOQ = (currentRow.LOCALESTOQUE)? null : ' ';
            currentRow.DSLOCALESTOQ = (currentRow.LOCALESTOQUE)? null : ' ';

            widget.getField('DSLOCALESTOQ').reload();
        }
    }

    this.initialize = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(success => {
            let dataAtual = moment().format('DD/MM/YYYY');
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            /*rowsToSet.INTERVALO = {
                                    "start": dataAtual,
                                    "end": dataAtual
                                  };
            rowsToSet.DTINICIAL = dataAtual;
            rowsToSet.DTFINAL = dataAtual; */
            
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                },
                {
                    "name": "IDUTILALMOX",
                    "operator": "=",
                    "value": "S"
                }
		    ];
            
            General.callRestEngine('est#/crud/paramfilial', 'FilterData', filter).then( response => {
                if(response.dataset.paramfilial[0]) {
                    widget.getField("DSALMOXARIFE").filterProperties.readOnly = false;
                    widget.getField("DSALMOXARIFE").validations = {"required": true};
                    if(response.dataset.paramfilial[0].IDUTILLCESTQ == 'S'){
                        widget.getField("DSLOCALESTOQ").filterProperties.readOnly = false;
                        widget.getField("DSLOCALESTOQ").validations = {"required": true};
                    } else{
                        widget.getField("DSLOCALESTOQ").filterProperties.readOnly = true;
                        widget.getField("DSLOCALESTOQ").validations = null;
                    }
                }else {
                    widget.getField("DSALMOXARIFE").filterProperties.readOnly = true;
                    widget.getField("DSALMOXARIFE").validations = null;
                    widget.getField("DSLOCALESTOQ").filterProperties.readOnly = true;
                    widget.getField("DSLOCALESTOQ").validations = null;
                }
                //rowsToSet
                ZhFilterPreferences.openFilterWidget(widget, []);
            });
            
            
        });       
        
        //funcao desnecessária basta colocar propiedade 'translate': true na coluna desejada.
       /* let fieldTipos = widget.getField('IDTIPOMOVIEST');
        let arrToTranslate = fieldTipos.dataSource.data;
        arrToTranslate.forEach(row =>{
            row.DSTIPOMOVIEST = ScreenService.i18n(row.DSTIPOMOVIEST);
        });*/
    };
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };
    
    function setDefaultValues(widget) {
        var data = moment().format('DD/MM/YYYY');

        widget.currentRow.INTERVALO =   {
                                            "start": data,
                                            "end": data
                                        };
        widget.currentRow.DTINICIAL = data;
        widget.currentRow.DTFINAL = data;
        widget.currentRow.REPORT_NAME = 'Est31250IrrEstoque';
        widget.currentRow.NRTPARVPROD = null;
        changeReport(widget);
    }
    
    this.setProductRangeOnFilter = function(args){
        var filter = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        
        var prodfin = filter.CDPRODFIN;
        prodfin = prodfin + "zzzzzzzzzzzzzzzzzzzz";
        prodfin = prodfin.substring(0, 20);
        var prodIni = {name: "CDPRODINI", operator: "=", value: filter.CDPRODINI};
        var prodFin = {name: "CDPRODFIN", operator: "=", value: prodfin};
        widget.dataSourceFilter.push(prodIni);
        widget.dataSourceFilter.push(prodFin);
    };

    function changeReport(widget) {
        switch(widget.currentRow.REPORT_NAME) {
            case 'Est31250IrrEstoque':
                setEST31200DefaultValues(widget.currentRow); break;
        }
    }

    this.changeReport = changeReport;

    function setEST31200DefaultValues(currentRow) {
        currentRow.CDALMOXARIFE = ' ';
        currentRow.CDLOCALESTOQ = ' ';
    }

    this.setMinMaxDate = function(widget){
        var interval = widget.getField("INTERVALO").value();
        if(interval){
            widget.getField('DTINICIAL').setValue(interval.start);
            widget.getField('DTFINAL').setValue(interval.end);
        }
    };

    this.checkProductRange = function(field) {
        var currentRow = field.widget.currentRow;

        if(currentRow.CDPRODUTOINI && currentRow.CDPRODUTOFIN) {
            var produtoIni = (currentRow.CDPRODUTOFIN)? currentRow.CDPRODINI.replace(/[\.\-]/g, '') : null;
            var produtoFin = (currentRow.CDPRODUTOFIN)? currentRow.CDPRODFIN.replace(/[\.\-]/g, '') : null;

            if(!General.comparaPratoProduto(produtoIni, produtoFin, getLocalVar('CDPICTPROD'))) {
                currentRow[field.outData[field.descriptionField]] = null;
                currentRow[field.outData[field.valueField]] = null;

                ScreenService.showMessage("O Produto Final não pode ser maior que o Produto Inicial.");
            }
        }
    };

    this.changeFilter = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;

        var filtro= [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filterRow.CDFILIAL
            },
            {
                "name":"CDALMOXARIFE",
                "operator":"=",
                "value": filterRow.CDALMOXARIFE ? filterRow.CDALMOXARIFE : null
            },
            {
                "name":"CDLOCALESTOQ",
                "operator":"=",
                "value": filterRow.CDLOCALESTOQ ? filterRow.CDLOCALESTOQ : null
            },
            {
                "name":"DTINICIAL",
                "operator":"=",
                "value": filterRow.DTINICIAL ? filterRow.DTINICIAL : null
            },
            {
                "name":"DTFINAL",
                "operator":"=",
                "value": filterRow.DTFINAL ? filterRow.DTFINAL : null
            },
            {
                "name":"NRTPARVPROD",
                "operator":"=",
                "value": filterRow.NRTPARVPROD ? filterRow.NRTPARVPROD : null
            },
            {
                "name":"CDARVPRODINI",
                "operator":"=",
                "value": filterRow.CDARVPRODINI ? filterRow.CDARVPRODINI : null
            },
            {
                "name":"CDARVPRODFIN",
                "operator":"=",
                "value": filterRow.CDARVPRODFIN ? filterRow.CDARVPRODFIN : null
            },
            {
                "name":"NRARVOREPROD",
                "operator":"=",
                "value": filterRow.NRARVOREPROD ? filterRow.NRARVOREPROD : 'T'
            }
        ];
        
        widget.dataSourceFilter = filtro;
        widget.reload();
        
    };
    
    function getFilter(widget, fields, prodFin) {
        let row = widget.appliedFilter.FILTER_ROW;
        let filter = [];
        fields.forEach((f) => {
            filter.push(
            {
                "name": f,
                "operator": "=",
                "value": (f !== 'CDPRODUTOFIN') ? row[f] : getProdFinFormatado(row.CDPRODUTOFIN)
            });
        });
        return filter;
    }
    
    function getProdFinFormatado(prodfin) {
        var masksize = getLocalVar('CDPICTPROD').replace(/[\.\-]/g, '').length - prodfin.length;
        return General.fill(prodfin, masksize, true, 'z');
    }
    
    this.setGrupoArvore = function(widget){
		var nmarvoreprod = widget.getField('NMARVOREPROD');
		if (widget.getField('DSTPARVPROD').value()){
			nmarvoreprod.dataSourceFilter[0].value = widget.currentRow.NRTPARVPROD;
			nmarvoreprod.readOnly = false;
			nmarvoreprod.reload();
		}else{
			nmarvoreprod.dataSourceFilter[0].value = null;
			nmarvoreprod.readOnly = true;
		}
		widget.currentRow.NMTPARVORE = '';
		widget.currentRow.NMARVOREPROD = '';
		widget.currentRow.NRARVOREPROD = '';
	    this.validaEstadoRangeProduto(widget);
	};
    
    this.validaEstadoRangeProduto = function(widget){
		var produtoIni = widget.getField('NMPRODUTOINI');
		var produtoFin = widget.getField('NMPRODUTOFIN');
		var tipoProduto = widget.getField('DSTPARVPROD');
		if (tipoProduto.value()){
			produtoIni.readOnly = true;
			widget.currentRow.NMPRODUTOINI = null;
			widget.currentRow.CDARVPRODINI = null;
			widget.currentRow.CDPRODUTOINI = null;
			widget.currentRow.CDNVPRODUTOINI = null;
			produtoIni.validations = {};
			produtoFin.readOnly = true;
			produtoFin.validations = {};
			widget.currentRow.NMPRODUTOFIN = null;
			widget.currentRow.CDARVPRODFIN = null;
			widget.currentRow.CDPRODUTOFIN = null;
			widget.currentRow.CDNVPRODUTOFIN = null;
		}else{
			produtoIni.readOnly = false;
			produtoIni.validations = {"required":true};
			produtoFin.readOnly = false;
			produtoFin.validations = {"required":true};
		}
	};
	
	this.requestGrupoTipoArvore = function(widget, fieldTreeProd){
		ProdTreeGroup.getAllGroups(fieldTreeProd)
			.then(function(allGroups){
				widget.currentRow.NRARVOREPROD = allGroups.join('_');
			})
			.catch(function(erro){
				ScreenService.showMessage(erro.data.error);
			});
	};
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
    this.setNameLayout = function(args){
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')){
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL'){
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        }else{
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
            ScreenService.showLoader();
            setTimeout((ok)=>{changeLayoutOrderby(args);}, 2000);
        }
    };
    
    var changeLayoutOrderby = function (args){
        
        var widget = args.owner;
        /*var orderByFilter = widget.dataSourceFilter.filter(filter => filter.operator == "ORDER_BY");
        if(orderByFilter)
            orderByFilter[0].name[0].name = orderby;
        */
        
        var orderByFilter = {name: [{name: orderby, direction: "ASC"}], value: null, operator: "ORDER_BY"};
        var filterToSet = widget.dataSourceFilter.filter(filter => filter.operator != "ORDER_BY");
        filterToSet.push(orderByFilter);
        widget.dataSourceFilter = filterToSet;
        widget.reload();
        ScreenService.hideLoader();
    };
    
    this.getDateFilter = function (interval){
        let value = EstUtil.getFieldValue('DTLANCMOVIEST','est31300_grid_movimentacao_de_estoque_grid', true);
        if(value){
            return value[interval];
        }
        return null;
    };
	
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Est31250_produtos_nao_atualizados_Controller', Est31250_produtos_nao_atualizados_Controller);
});
