package com.javaseleniumtemplate.tests.semLote;
import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.semLote.AjusteInventarioNaoControlaLoteFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.semLote.AjusteInventarioNaoControlaLotePage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class AjusteDeInventarioNaoControlaLoteTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    AjusteInventarioNaoControlaLoteFlows ajusteInventarioNaoControlaLoteFlows;
    AjusteInventarioNaoControlaLotePage ajusteInventarioNaoControlaLotePage;


    @Test(description = "Est-28")
@Ignore
    public void EfetuarAjusteInventarioNaoControlaLote(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaLoteFlows = new AjusteInventarioNaoControlaLoteFlows();
        ajusteInventarioNaoControlaLotePage = new AjusteInventarioNaoControlaLotePage();


            //ParameteresLançamento:
                String quantidade = "5";
                String cmpDesc = "Teste Automatizado";
                String descProduto = "Hela Poultry Broth Paste Clear KG";
                String descAlmoxarifado = "HELA MATRIZ";
                String descLote = "00231100";
                String descUnidade = "HELA INGREDIENTES BRASIL";
                String descOperador = "Deivison";
                String valorEstoqueEsperado = "5";
                String valorUnitarioLancado = "0";



        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaLoteFlows.aplicarFiltro(descUnidade,descOperador);
        ajusteInventarioNaoControlaLoteFlows.adicionarAjusteIventario(quantidade,cmpDesc,descProduto,descAlmoxarifado,descLote);

        //Banco

        String numeroLancamento = ajusteInventarioNaoControlaLotePage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = ajusteInventarioNaoControlaLotePage.retornaNumeroLacamento();
        //Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario


    }



    @Test(description = "Est-29")
    @Ignore
    public void EditarAjusteInventarioNaoControlaLote(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaLoteFlows = new AjusteInventarioNaoControlaLoteFlows();
        ajusteInventarioNaoControlaLotePage = new AjusteInventarioNaoControlaLotePage();


        //ParameteresLançamento:

        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";
        //Parameteres_Editar
        String quantidade2 = "2";
        String cmpDesc2 = "Deletar";
        String descProduto2 = "Ochsenbuillon Paste (Hela 7565810050001)";
        String descLote2 = "20013001";



        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaLoteFlows.aplicarFiltro(descUnidade,descOperador);
        ajusteInventarioNaoControlaLoteFlows.editarAjusteIventario(cmpDesc2,quantidade2,descProduto2,descAlmoxarifado,descLote2);
    }
    @Test (description = "Est-30")
    @Ignore
    public void ExcluirAjusteInventarioNaoControlaLote(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaLoteFlows = new AjusteInventarioNaoControlaLoteFlows();
        ajusteInventarioNaoControlaLotePage = new AjusteInventarioNaoControlaLotePage();


        //ParameteresLançamento:

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";



        //Rotinas:
        loginFlows.efetuarLogin();
       // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaLoteFlows.aplicarFiltro(descUnidade,descOperador);
        ajusteInventarioNaoControlaLoteFlows.excluirAjusteIventario();
    }
    @Test (description = "Est-38")
    @Ignore
    public void importarAjusteInventarioNaoControlaLote(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioNaoControlaLoteFlows = new AjusteInventarioNaoControlaLoteFlows();
        ajusteInventarioNaoControlaLotePage = new AjusteInventarioNaoControlaLotePage();

        //Parameteres

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison"; //  Constuido o caminho para ser usado somente com esse nome.

        loginFlows.efetuarLogin();
      //  mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioNaoControlaLoteFlows.aplicarFiltro(descUnidade,descOperador);
        ajusteInventarioNaoControlaLoteFlows.importarAjusteInventario();

    }



}




